'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const inputBase = require('./inputBase-ae3f2f06.js');
require('./utils-ae677cb5.js');

const taskAnswerCorrectionCss = ".sc-task-answer-correction-h{display:block}.correction-hidden.sc-task-answer-correction-h{display:none}";
const TaskAnswerCorrectionStyle0 = taskAnswerCorrectionCss;

const TaskAnswerCorrection = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.display = index.createEvent(this, "display", 7);
        this.displayOn = "submit";
        this.showAnswer = false;
        this.preventChanges = false;
        this.displayCorrection = false;
        this.onDisplayEvent = undefined;
    }
    componentWillLoad() {
        const inputs = inputBase.childInputs(this.host);
        for (let input of inputs) {
            input.disabled = true;
        }
    }
    handleDisplayUpdate() {
        const inputs = inputBase.childInputs(this.host);
        for (let input of inputs) {
            input.disabled = !this.displayCorrection;
        }
        this.display.emit(this.displayCorrection);
    }
    handleDisplay(event) {
        // TODO: This all could be refactored or abandoned
        if (this.onDisplayEvent) {
            let command = this.onDisplayEvent;
            if (command.includes("${visible}")) {
                command = command.replace("${visible}", event.detail.toString());
            }
            eval(command);
        }
    }
    render() {
        return (index.h(index.Host, { key: '8941a6c13fcbc1abeb7deb780143d651e92df960', class: this.displayCorrection ? "" : "correction-hidden" }, index.h("slot", { key: '089b450d018cff137ee2152aa76ce1326436adbe' })));
    }
    get host() { return index.getElement(this); }
    static get watchers() { return {
        "displayCorrection": ["handleDisplayUpdate"]
    }; }
};
TaskAnswerCorrection.style = TaskAnswerCorrectionStyle0;

exports.task_answer_correction = TaskAnswerCorrection;

//# sourceMappingURL=task-answer-correction.cjs.entry.js.map