'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const inputBase = require('./inputBase-ae3f2f06.js');
const utils = require('./utils-ae677cb5.js');
const floatingUi_dom_esm = require('./floating-ui.dom.esm-d65af737.js');

const taskInputMultiselectCss = ".sc-task-input-multiselect-h{display:block}label.sc-task-input-multiselect{display:block;margin-bottom:15px;margin-top:0}label.sc-task-input-multiselect .select.sc-task-input-multiselect{display:block;margin-top:5px;text-transform:none}label.sc-task-input-multiselect .select.sc-task-input-multiselect select.sc-task-input-multiselect{font-weight:400;vertical-align:top;width:100%}label.disabled.sc-task-input-multiselect{color:rgba(95, 107, 124, 0.6)}label.label.inline.sc-task-input-multiselect{line-height:30px}label.inline.sc-task-input-multiselect .select.sc-task-input-multiselect{display:inline-block;margin:0 0 0 5px;vertical-align:top}.options.sc-task-input-multiselect{position:absolute;top:0;left:0;z-index:100;background-color:#fff;border-bottom:none;border-top:1px solid #0000;-webkit-box-shadow:0 4px 20px 1px #0007161a;box-shadow:0 4px 20px 1px #0007161a;-webkit-box-sizing:border-box;box-sizing:border-box;outline:none;overflow-y:scroll;height:-webkit-max-content;height:-moz-max-content;height:max-content;width:-webkit-max-content;width:-moz-max-content;width:max-content;max-height:200px}.options-hidden.sc-task-input-multiselect{display:none}.options.sc-task-input-multiselect select.sc-task-input-multiselect{height:150px}.select.sc-task-input-multiselect select.sc-task-input-multiselect{display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border:none;border-radius:3px;cursor:pointer;font-size:14px;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;padding:5px 10px;text-align:left;vertical-align:middle;background-color:#f6f7f9;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);color:#1c2127;-moz-appearance:none;-webkit-appearance:none;border-radius:3px;height:30px;padding:0 25px 0 10px;width:100%}.select.sc-task-input-multiselect select.sc-task-input-multiselect>*.sc-task-input-multiselect{-webkit-box-flex:0;-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0}.select.sc-task-input-multiselect select.sc-task-input-multiselect>.fill.sc-task-input-multiselect{-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:1;flex-shrink:1}.select.sc-task-input-multiselect select.sc-task-input-multiselect::before,.select.sc-task-input-multiselect select.sc-task-input-multiselect>*.sc-task-input-multiselect{margin-right:7px}.select.sc-task-input-multiselect select.sc-task-input-multiselect:empty::before,.select.sc-task-input-multiselect select.sc-task-input-multiselect>.sc-task-input-multiselect:last-child{margin-right:0}.select.sc-task-input-multiselect select.sc-task-input-multiselect:hover{background-clip:padding-box;background-color:#edeff2;-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1)}.select.sc-task-input-multiselect select.sc-task-input-multiselect:active,.select.sc-task-input-multiselect select.active.sc-task-input-multiselect{background-color:#dce0e5;background-image:none;-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 1px 2px rgba(17, 20, 24, 0.2);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 1px 2px rgba(17, 20, 24, 0.2)}.select.sc-task-input-multiselect select.sc-task-input-multiselect:disabled,.select.sc-task-input-multiselect select.disabled.sc-task-input-multiselect{background-color:rgba(211, 216, 222, 0.5);background-image:none;-webkit-box-shadow:none;box-shadow:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed;outline:none}.select.sc-task-input-multiselect select.sc-task-input-multiselect:disabled.active,.select.sc-task-input-multiselect select.disabled.active.sc-task-input-multiselect{background:rgba(211, 216, 222, 0.7)}.select.minimal.sc-task-input-multiselect select.sc-task-input-multiselect{background:none;-webkit-box-shadow:none;box-shadow:none}.select.minimal.sc-task-input-multiselect select.sc-task-input-multiselect:hover{background:rgba(143, 153, 168, 0.15);-webkit-box-shadow:none;box-shadow:none;color:#1c2127;text-decoration:none}.select.minimal.sc-task-input-multiselect select.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.active.sc-task-input-multiselect{background:rgba(143, 153, 168, 0.3);-webkit-box-shadow:none;box-shadow:none;color:#1c2127}.select.minimal.sc-task-input-multiselect select.sc-task-input-multiselect:disabled,.select.minimal.sc-task-input-multiselect select.disabled.sc-task-input-multiselect{background:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed}.select.minimal.sc-task-input-multiselect select.sc-task-input-multiselect:disabled.active,.select.minimal.sc-task-input-multiselect select.disabled.active.sc-task-input-multiselect{background:rgba(143, 153, 168, 0.3)}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect{color:#215db0}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:hover,.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-primary.active.sc-task-input-multiselect{background:none;-webkit-box-shadow:none;box-shadow:none;color:#215db0}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:hover{background:rgba(45, 114, 210, 0.15);color:#215db0}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-primary.active.sc-task-input-multiselect{background:rgba(45, 114, 210, 0.3);color:#215db0}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:disabled,.select.minimal.sc-task-input-multiselect select.intent-primary.disabled.sc-task-input-multiselect{background:none;color:rgba(33, 93, 176, 0.5)}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect:disabled.active,.select.minimal.sc-task-input-multiselect select.intent-primary.disabled.active.sc-task-input-multiselect{background:rgba(45, 114, 210, 0.3)}.select.minimal.sc-task-input-multiselect select.intent-primary.sc-task-input-multiselect .button-spinner.sc-task-input-multiselect .spinner-head.sc-task-input-multiselect{stroke:#215db0}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect{color:#1c6e42}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:hover,.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-success.active.sc-task-input-multiselect{background:none;-webkit-box-shadow:none;box-shadow:none;color:#1c6e42}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:hover{background:rgba(35, 133, 81, 0.15);color:#1c6e42}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-success.active.sc-task-input-multiselect{background:rgba(35, 133, 81, 0.3);color:#1c6e42}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:disabled,.select.minimal.sc-task-input-multiselect select.intent-success.disabled.sc-task-input-multiselect{background:none;color:rgba(28, 110, 66, 0.5)}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect:disabled.active,.select.minimal.sc-task-input-multiselect select.intent-success.disabled.active.sc-task-input-multiselect{background:rgba(35, 133, 81, 0.3)}.select.minimal.sc-task-input-multiselect select.intent-success.sc-task-input-multiselect .button-spinner.sc-task-input-multiselect .spinner-head.sc-task-input-multiselect{stroke:#1c6e42}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect{color:#935610}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:hover,.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-warning.active.sc-task-input-multiselect{background:none;-webkit-box-shadow:none;box-shadow:none;color:#935610}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:hover{background:rgba(200, 118, 25, 0.15);color:#935610}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-warning.active.sc-task-input-multiselect{background:rgba(200, 118, 25, 0.3);color:#935610}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:disabled,.select.minimal.sc-task-input-multiselect select.intent-warning.disabled.sc-task-input-multiselect{background:none;color:rgba(147, 86, 16, 0.5)}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect:disabled.active,.select.minimal.sc-task-input-multiselect select.intent-warning.disabled.active.sc-task-input-multiselect{background:rgba(200, 118, 25, 0.3)}.select.minimal.sc-task-input-multiselect select.intent-warning.sc-task-input-multiselect .button-spinner.sc-task-input-multiselect .spinner-head.sc-task-input-multiselect{stroke:#935610}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect{color:#ac2f33}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:hover,.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-danger.active.sc-task-input-multiselect{background:none;-webkit-box-shadow:none;box-shadow:none;color:#ac2f33}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:hover{background:rgba(205, 66, 70, 0.15);color:#ac2f33}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:active,.select.minimal.sc-task-input-multiselect select.intent-danger.active.sc-task-input-multiselect{background:rgba(205, 66, 70, 0.3);color:#ac2f33}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:disabled,.select.minimal.sc-task-input-multiselect select.intent-danger.disabled.sc-task-input-multiselect{background:none;color:rgba(172, 47, 51, 0.5)}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect:disabled.active,.select.minimal.sc-task-input-multiselect select.intent-danger.disabled.active.sc-task-input-multiselect{background:rgba(205, 66, 70, 0.3)}.select.minimal.sc-task-input-multiselect select.intent-danger.sc-task-input-multiselect .button-spinner.sc-task-input-multiselect .spinner-head.sc-task-input-multiselect{stroke:#ac2f33}.select.large.sc-task-input-multiselect select.sc-task-input-multiselect{font-size:16px;height:40px;padding-right:35px}.select.sc-task-input-multiselect select.sc-task-input-multiselect:disabled{background-color:rgba(211, 216, 222, 0.5);-webkit-box-shadow:none;box-shadow:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed}.select.sc-task-input-multiselect::after,.select.sc-task-input-multiselect .icon.sc-task-input-multiselect{color:#5f6b7c;pointer-events:none;position:absolute;right:7px;top:7px}.disabled.select.sc-task-input-multiselect::after,.select.sc-task-input-multiselect .disabled.icon.sc-task-input-multiselect{color:rgba(95, 107, 124, 0.6)}.select.sc-task-input-multiselect{display:inline-block;letter-spacing:normal;position:relative;vertical-align:middle}.select.sc-task-input-multiselect select.sc-task-input-multiselect::-ms-expand{display:none}.select.sc-task-input-multiselect .icon.sc-task-input-multiselect{color:#5f6b7c}.select.sc-task-input-multiselect .icon.sc-task-input-multiselect:hover{color:#1c2127}.select.large.sc-task-input-multiselect::after,.select.large.sc-task-input-multiselect .icon.sc-task-input-multiselect{right:12px;top:12px}.select.fill.sc-task-input-multiselect,.select.fill.sc-task-input-multiselect select.sc-task-input-multiselect{width:100%}.select.sc-task-input-multiselect::after{font-family:\"blueprint-icons-16\", sans-serif;font-size:16px;font-style:normal;font-variant:normal;font-weight:400;line-height:1;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;content:\"\\f184\"}";
const TaskInputMultiselectStyle0 = taskInputMultiselectCss;

const TaskInputMultiselect = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.inputUpdated = index.createEvent(this, "inputUpdated", 7);
        this.registerKeyboardShortcut = index.createEvent(this, "registerKeyboardShortcut", 7);
        this.optionsMap = new Map();
        this.formUpdated = inputBase.InputBase.prototype.formUpdated;
        this.setupDependentInputs = inputBase.InputBase.prototype.setupDependentInputs;
        this.hasAnswerToValidate = inputBase.InputBase.prototype.hasAnswerToValidate;
        this.handleParentElementUpdate = inputBase.InputBase.prototype.handleParentElementUpdate;
        this.fromInputUpdated = inputBase.InputBase.prototype.fromInputUpdated.bind(this);
        this.name = undefined;
        this.label = undefined;
        this.labelClass = undefined;
        this.required = undefined;
        this.active = undefined;
        this.disabled = undefined;
        this.disableIf = undefined;
        this.requireIf = undefined;
        this.requiredIndicator = undefined;
        this.displayOn = undefined;
        this.displayIf = undefined;
        this.value = undefined;
        this.valueFrom = undefined;
        this.hidden = undefined;
        this.preventChanges = undefined;
        this.answer = undefined;
        this.answerCorrection = undefined;
        this.placeholder = "Select options";
        this.values = [];
        this.shortcutMap = new Map();
        this.optionsDisplayed = undefined;
    }
    connectedCallback() {
        inputBase.InputBase.prototype.connectedCallback.bind(this)();
    }
    async validateAgainstAnswer() { return inputBase.InputBase.prototype.validateAgainstAnswer.bind(this)(); }
    async setShowCorrections() { return inputBase.InputBase.prototype.setShowCorrections.bind(this)(); }
    componentWillLoad() {
        inputBase.InputBase.prototype.componentWillLoad.bind(this)();
        this.options = utils.gatherInputOptions(this.host);
        for (let option of this.options) {
            this.optionsMap[option.value] = option.innerHTML;
        }
        for (let ks of utils.inputOptionKeyboardShortcuts(this.options)) {
            this.shortcutMap[ks.keys] = ks.value;
            this.registerKeyboardShortcut.emit(ks);
        }
    }
    componentDidLoad() {
        this.button.addEventListener("click", this.handleButtonClick.bind(this));
        document.addEventListener("click", this.handleDocumentClick.bind(this));
        document.addEventListener("blur", this.handleBlur.bind(this), { capture: true });
    }
    disconnectedCallback() {
        inputBase.InputBase.prototype.displayOnCallback.bind(this)();
        document.removeEventListener("click", this.handleDocumentClick.bind(this));
        document.removeEventListener("blur", this.handleBlur.bind(this), { capture: true });
    }
    handleButtonClick() {
        this.optionsDisplayed = !this.optionsDisplayed;
        if (this.optionsDisplayed) {
            this.cleanup = floatingUi_dom_esm.autoUpdate(this.button, this.optionsDropdown, this.updatePosition.bind(this));
        }
        else if (this.cleanup) {
            this.cleanup();
        }
    }
    handleDocumentClick(event) {
        if (!this.host.contains(event.target)) {
            this.optionsDisplayed = false;
        }
    }
    handleBlur(event) {
        if (!this.host.contains(event.target)) {
            this.optionsDisplayed = false;
        }
    }
    updatePosition() {
        floatingUi_dom_esm.computePosition(this.button, this.optionsDropdown, {
            placement: "bottom-start",
            middleware: [floatingUi_dom_esm.offset(6), floatingUi_dom_esm.flip(), floatingUi_dom_esm.shift({ padding: 5 })]
        }).then(({ x, y }) => {
            Object.assign(this.optionsDropdown.style, {
                left: `${x}px`,
                top: `${y}px`,
            });
        });
    }
    handleChange(event) {
        this.values = Array.from(event.target.selectedOptions).map(v => v.value);
    }
    async readyToSubmit() {
        return Boolean(this.values);
    }
    handleValueUpdate() {
        this.value = this.values.join(",");
        this.inputUpdated.emit(this.input.form);
    }
    handleOptionSelect(e, value) {
        e.preventDefault();
        if (this.values.includes(value)) {
            this.values = this.values.filter(v => v !== value);
        }
        else {
            this.values = [...this.values, value];
        }
    }
    render() {
        return (index.h(index.Host, { key: '6e80efa9132f40fa928f346081a9fca0fb3daa03' }, !this.hidden && index.h("label", { key: '2f23da02a09e55d58ab068608d88c0c9cf5dff76' }, this.label, index.h("div", { key: '93bd88ee64ca1af4b75a64002956839be970b566', class: "multiselect" }, index.h("div", { key: 'f397dce2b65dedc6e6d8c5d26236ee2e296d50b6', class: "selectbar" }, index.h("button", { key: '60ba9b090253af3a5cee3fb90c3c844cfc16a2b8', type: "button", ref: el => this.button = el }, this.placeholder)), index.h("div", { key: '4ab48577a0f5052a8ca99c42be800931301b78d5', class: "options " + (this.optionsDisplayed ? "" : "options-hidden"), ref: el => this.optionsDropdown = el }, index.h("select", { key: '2638062417c148841e673cc237a11f048c772531', name: this.name, required: this.required, disabled: this.disabled, onChange: e => this.handleChange(e), multiple: true, style: { display: "none" }, ref: el => this.input = el }, this.options.map(option => index.h("option", { value: option.value, selected: this.values.includes(option.value) }, option.innerHTML))), index.h("div", { key: '9b5f722a844a3fb24c9772a7c646805152cbedc7', class: "option-list" }, this.options.map(option => index.h("div", { onClick: (e) => this.handleOptionSelect.bind(this)(e, option.value) }, index.h("div", { tabindex: "0", class: "item" }, index.h("task-icon", { icon: this.values.includes(option.value) ? "small-tick" : "blank" }), option.innerHTML))))), index.h("div", { key: 'b3a6bb8b7cf2938109d7481c253249062e78239d', class: "selectedvalues" }, this.values.map(v => index.h("task-tag", { small: true }, this.optionsMap[v])))))));
    }
    static get formAssociated() { return true; }
    get host() { return index.getElement(this); }
    static get watchers() { return {
        "values": ["handleValueUpdate"]
    }; }
};
TaskInputMultiselect.style = TaskInputMultiselectStyle0;

exports.task_input_multiselect = TaskInputMultiselect;

//# sourceMappingURL=task-input-multiselect.cjs.entry.js.map