'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');

const taskInstructionsCss = ":host{display:block}.drawer{font-family:sans-serif}.header{padding:1.5rem;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;-ms-flex-align:center;align-items:center;border-bottom:1px solid #ddd;-ms-flex:0 1 auto;flex:0 1 auto}.close{margin:0;padding:0;border:none;background-color:transparent;cursor:pointer;background-image:url(\"data:image/svg+xml,%0A%3Csvg width='15px' height='16px' viewBox='0 0 15 16' version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink'%3E%3Cg id='Page-1' stroke='none' stroke-width='1' fill='none' fill-rule='evenodd'%3E%3Cg id='2.-Menu' transform='translate(-15.000000, -13.000000)' stroke='%23000000'%3E%3Cg id='Group' transform='translate(15.000000, 13.521000)'%3E%3Cpath d='M0,0.479000129 L15,14.2971819' id='Path-3'%3E%3C/path%3E%3Cpath d='M0,14.7761821 L15,-1.24344979e-14' id='Path-3'%3E%3C/path%3E%3C/g%3E%3C/g%3E%3C/g%3E%3C/svg%3E\");width:15px;height:15px}.wrapper{position:fixed;top:0;right:0;bottom:0;height:100%;width:600px;z-index:9999;-webkit-transition:-webkit-transform 0.3s;transition:-webkit-transform 0.3s;transition:transform 0.3s;transition:transform 0.3s, -webkit-transform 0.3s;will-change:transform;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-webkit-transform:translateX(550px);transform:translateX(550px)}.body{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex:max-content;flex:max-content;background-color:#fff;overflow-x:hidden;overflow-y:hidden;height:100%;-webkit-box-shadow:0 2px 6px #777;box-shadow:0 2px 6px #777}.tabbar{width:50px;-ms-flex:none;flex:none}.tab{width:150px;height:50px;-webkit-transform:rotate(-90deg) translateY(-100px);transform:rotate(-90deg) translateY(-100px);-webkit-transform-origin:bottom right 0;transform-origin:bottom right 0;color:#fff;background-color:#384047;cursor:pointer;border-radius:8px 8px 0 0}.tab>div{padding-top:15px;text-align:center}.content{-ms-flex:1 1 auto;flex:1 1 auto;padding:1.5rem;overflow-y:auto;overflow-x:hidden}.contentSlot{width:100%;height:100%}.drawer.is-active .overlay{display:block}.drawer.is-visible .wrapper{-webkit-transform:translateX(0);transform:translateX(0)}.drawer.is-visible .overlay{opacity:0.5}.overlay{display:none;position:fixed;top:0;right:0;bottom:0;left:0;width:100%;z-index:200;opacity:0;-webkit-transition:opacity 0.3s;transition:opacity 0.3s;will-change:opacity;background-color:#000;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}";
const TaskInstructionsStyle0 = taskInstructionsCss;

const TaskInstructions = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.tab = "Instructions";
        this.header = "Task Instructions";
        this.open = false;
        this.visible = false;
        this.active = false;
    }
    tabClicked(e) {
        this.open = !this.open;
        e.preventDefault();
    }
    updateActiveVisible(newValue) {
        if (newValue) {
            this.active = true;
            document.documentElement.style.overflow = 'hidden';
            setTimeout(() => this.visible = true, 50);
        }
        else {
            this.visible = false;
            document.documentElement.style.overflow = '';
            setTimeout(() => this.active = false, 350);
        }
    }
    handleKeyDown(ev) {
        if (ev.key === 'Escape') {
            this.open = false;
        }
    }
    /*
    Remaining work:
    * Make the tab button a functional component with its own listener that captures
      the click so it isn't transmitted to the tab bar, then add a close listener to the tabbar
    * Option for left and right
    * Option to set width
    * option to set tab color
    * option to set size
     */
    render() {
        return (index.h("div", { key: 'ce444468564d5b815e3b7a68a79c6382697bf543', class: "drawer" + (this.visible ? " is-visible" : "") + (this.active ? " is-active" : ""), tabindex: "0" }, index.h("div", { key: '27af424e705a75eb4505b651c49e62ca433861f1', class: "overlay", tabindex: "-1", onClick: () => this.open = false }), index.h("div", { key: 'c60d86ec472a9015f619ac6a04dbae0b3c52dcb0', class: "wrapper" }, index.h("div", { key: 'd709ba6d61022f6a0adc66db95f1ee0d7a1b291f', class: "tabbar" }, index.h("div", { key: '31108fda56cb05a856defd48e3a79951ebfec0c3', class: "tab", onClick: (e) => this.tabClicked(e) }, index.h("div", { key: 'ec8144195190bc5fb03b212e4d4af7c993084d83' }, this.tab))), index.h("div", { key: '1fccfa97d1068e546614206cd009ad2c47a641c4', class: "body" }, index.h("div", { key: '0ed4c97a7c7e381eb4b67bc172de43b6adee11d3', class: "header" }, index.h("div", { key: '543bc3c4110173ee665794badf5bc0d39e006e4c', class: "title" }, this.header), index.h("button", { key: '74185c467c7984ebbdf8b9be8621eab0a8956a7a', class: "close", onClick: () => this.open = false })), index.h("div", { key: '7db39300b6faf2d3ae0cef5ca96ba31f5ff87957', class: "content" }, index.h("div", { key: '2ec1563787d11e3cb800fdb9175855fb388c92be', class: "contentSlot" }, index.h("slot", { key: 'e438fc9635ff700415c4bf2005930e78867cdd70' })))))));
    }
    static get watchers() { return {
        "open": ["updateActiveVisible"]
    }; }
};
TaskInstructions.style = TaskInstructionsStyle0;

exports.task_instructions = TaskInstructions;

//# sourceMappingURL=task-instructions.cjs.entry.js.map