'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const inputBase = require('./inputBase-ae3f2f06.js');
require('./utils-ae677cb5.js');

const taskStepCss = ".sc-task-step-h{display:block;margin-bottom:0.5rem;margin-right:0.5rem;background-color:rgb(251 179 96 / 0.2);padding:10px;width:100%;-webkit-box-shadow:0 0 0 1px rgba(17, 20, 24, 0.1), 0 1px 1px rgba(17, 20, 24, 0.2), 0 2px 6px rgba(17, 20, 24, 0.2);box-shadow:0 0 0 1px rgba(17, 20, 24, 0.1), 0 1px 1px rgba(17, 20, 24, 0.2), 0 2px 6px rgba(17, 20, 24, 0.2);-webkit-box-sizing:border-box;box-sizing:border-box;border-radius:3px;-webkit-transition:-webkit-transform 200ms cubic-bezier(0.4, 1, 0.75, 0.9), -webkit-box-shadow 200ms cubic-bezier(0.4, 1, 0.75, 0.9);transition:-webkit-transform 200ms cubic-bezier(0.4, 1, 0.75, 0.9), -webkit-box-shadow 200ms cubic-bezier(0.4, 1, 0.75, 0.9);transition:transform 200ms cubic-bezier(0.4, 1, 0.75, 0.9), box-shadow 200ms cubic-bezier(0.4, 1, 0.75, 0.9), -webkit-transform 200ms cubic-bezier(0.4, 1, 0.75, 0.9), -webkit-box-shadow 200ms cubic-bezier(0.4, 1, 0.75, 0.9)}.active.sc-task-step-h{background-color:rgb(114 202 155 / 40%);-webkit-box-shadow:0 0 0 1px rgb(17 20 24 / 10%), 0 4px 8px rgb(17 20 24 / 20%), 0 18px 46px 6px rgb(17 20 24 / 20%);box-shadow:0 0 0 1px rgb(17 20 24 / 10%), 0 4px 8px rgb(17 20 24 / 20%), 0 18px 46px 6px rgb(17 20 24 / 20%)}.content-hidden.sc-task-step{display:none}h3.sc-task-step{margin-top:3px;width:100%;cursor:pointer}task-icon.sc-task-step{height:18px;margin-right:3px}";
const TaskStepStyle0 = taskStepCss;

const TaskStep = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.cardReadyToSubmit = index.createEvent(this, "cardReadyToSubmit", 7);
        this.cardClicked = index.createEvent(this, "cardClicked", 7);
        this.label = undefined;
        this.active = undefined;
        this.open = false;
    }
    componentWillLoad() {
        this.open = this.active;
    }
    handleOpenToggle() {
        this.open = !this.open;
        if (this.open) {
            this.cardClicked.emit(this.host);
        }
    }
    activeUpdated(newValue) {
        this.open = newValue;
        for (let input of inputBase.childInputs(this.host)) {
            input.active = newValue;
        }
    }
    handleInputUpdated() {
        this.readyToSubmit().then(ready => {
            this.cardReadyToSubmit.emit(ready);
        });
    }
    async readyToSubmit() {
        return Promise.all(inputBase.requiredChildInputs(this.host).map(i => i.readyToSubmit()))
            .then(values => {
            return values.every(Boolean);
        });
    }
    render() {
        return (index.h(index.Host, { key: '2974edb4b0c4f1967e8df72ab34614ca078eda3f', class: this.active ? "active" : "" }, index.h("h3", { key: 'e65bcd763536474e220e79415add8016b9c34b4e', onClick: this.handleOpenToggle.bind(this) }, index.h("task-icon", { key: 'f7018a216f50be41e9059657c0b5f14761822039', icon: this.open ? "caret-down" : "caret-right" }), this.label), index.h("div", { key: '6af91a146f0157bd0d35b78993ac1e61b0f4a46d', class: !this.open && "content-hidden" }, index.h("slot", { key: '92e94494e5e10ebdbfba287e0ba923f1a9840413' }))));
    }
    get host() { return index.getElement(this); }
    static get watchers() { return {
        "active": ["activeUpdated"]
    }; }
};
TaskStep.style = TaskStepStyle0;

exports.task_step = TaskStep;

//# sourceMappingURL=task-step.cjs.entry.js.map