'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const utils = require('./utils-ae677cb5.js');

const taskStepsCss = ".sc-task-steps-h{display:block}";
const TaskStepsStyle0 = taskStepsCss;

const TaskSteps = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.activeStep = 0;
        this.steps = undefined;
    }
    componentWillLoad() {
        this.steps = Array.from(this.host.children).filter(node => node.nodeName === "TASK-STEP");
        this.updateActiveStep();
    }
    updateActiveStep() {
        for (let step of this.steps) {
            step.active = this.activeStep === this.steps.indexOf(step);
        }
    }
    cardClickedHandler(event) {
        const target = event.detail;
        if (this.steps.includes(target)) {
            this.activeStep = this.steps.indexOf(target);
        }
    }
    cardReadyToSubmitHandler(event) {
        if (event.detail && !utils.ignoreKeypress()) {
            this.activeStep = Math.min(this.activeStep + 1, this.steps.length - 1);
        }
    }
    activeStepUpdated() {
        this.updateActiveStep();
    }
    render() {
        return (index.h(index.Host, { key: 'bbc318c8cc88ad26b6fd143abfb936989328b69d' }, index.h("slot", { key: '368a76619c5e0ada7c0b2ed7590a63fd89ae5f78' })));
    }
    get host() { return index.getElement(this); }
    static get watchers() { return {
        "activeStep": ["activeStepUpdated"]
    }; }
};
TaskSteps.style = TaskStepsStyle0;

exports.task_steps = TaskSteps;

//# sourceMappingURL=task-steps.cjs.entry.js.map