'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const floatingUi_dom_esm = require('./floating-ui.dom.esm-d65af737.js');

const taskTooltipCss = ".sc-task-tooltip-h{display:inline-block}.tooltip.sc-task-tooltip{position:absolute;top:0;left:0;z-index:100;background-color:#fff;border-bottom:none;border-top:1px solid #0000;-webkit-box-shadow:0 4px 20px 1px #0007161a;box-shadow:0 4px 20px 1px #0007161a;-webkit-box-sizing:border-box;box-sizing:border-box;outline:none;overflow-y:auto;height:-webkit-max-content;height:-moz-max-content;height:max-content;width:-webkit-max-content;width:-moz-max-content;width:max-content;max-height:600px;max-width:600px}.tooltip-hidden.sc-task-tooltip{display:none}";
const TaskTooltipStyle0 = taskTooltipCss;

const TaskTooltip = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.icon = undefined;
        this.display = false;
    }
    componentDidLoad() {
        this.target.addEventListener("click", this.handleTargetClick.bind(this));
        this.tooltip.addEventListener("click", this.handleTooltipClick.bind(this));
    }
    handleTargetClick() {
        this.display = !this.display;
        if (this.display) {
            this.cleanup = floatingUi_dom_esm.autoUpdate(this.target, this.tooltip, this.updatePosition.bind(this));
        }
        else if (this.cleanup) {
            this.cleanup();
        }
    }
    handleTooltipClick() {
        this.display = false;
    }
    updatePosition() {
        floatingUi_dom_esm.computePosition(this.target, this.tooltip, {
            placement: "bottom-start",
            middleware: [floatingUi_dom_esm.offset(6), floatingUi_dom_esm.flip(), floatingUi_dom_esm.shift({ padding: 5 })]
        }).then(({ x, y }) => {
            Object.assign(this.tooltip.style, {
                left: `${x}px`,
                top: `${y}px`,
            });
        });
    }
    render() {
        return (index.h(index.Host, { key: 'c099f41f791eaab5392170b0eaf23dd390e27e6c' }, index.h("task-icon", { key: '556b3bc1414dc35bc209ca6f285e9c28b784806a', icon: this.icon, ref: el => this.target = el }), index.h("div", { key: 'f6b050ef8325d21d1f926995c90b21177d5bb9d6', class: "tooltip " + (this.display ? "" : "tooltip-hidden"), ref: el => this.tooltip = el }, index.h("slot", { key: '3553634da4390a8156dffe6dd540e7a82a1b9bd9' }))));
    }
    get host() { return index.getElement(this); }
};
TaskTooltip.style = TaskTooltipStyle0;

exports.task_tooltip = TaskTooltip;

//# sourceMappingURL=task-tooltip.cjs.entry.js.map