'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4e4a0217.js');
const inputBase = require('./inputBase-ae3f2f06.js');
require('./utils-ae677cb5.js');

const taskVarCss = ".sc-task-var-h{display:inline}";
const TaskVarStyle0 = taskVarCss;

const TaskVar = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.data = undefined;
        this.name = undefined;
        this.value = undefined;
    }
    componentWillLoad() {
        if (this.data) {
            let element = this.host;
            while (element.parentElement && !this.value) {
                element = element.parentElement;
                if (this.data in element.dataset) {
                    this.value = element.dataset[this.data];
                }
            }
        }
        else if (this.name) {
            if (['interactive', 'complete'].includes(document.readyState)) {
                this.setupInputListener();
            }
            else {
                this.loadCallback = this.setupInputListener.bind(this);
                document.addEventListener("load", this.setupInputListener);
            }
        }
    }
    disconnectedCallback() {
        if (this.loadCallback) {
            document.removeEventListener("load", this.loadCallback);
        }
    }
    setupInputListener() {
        this.inputCallback = this.inputUpdated.bind(this);
        inputBase.attachInputListener(this.name, this.inputCallback)
            .then(input => {
            this.input = input;
            this.inputUpdated();
        });
    }
    inputUpdated() {
        if (this.input) {
            this.value = this.input.value;
        }
    }
    render() {
        return (index.h(index.Host, { key: 'd29f884d8c2027bcab046522d49671e149ecf81d' }, this.value, index.h("slot", { key: '52b5091e98ec0dfec7546d39b924fcd1aaffec6c' })));
    }
    get host() { return index.getElement(this); }
};
TaskVar.style = TaskVarStyle0;

exports.task_var = TaskVar;

//# sourceMappingURL=task-var.cjs.entry.js.map