import { Host, h } from "@stencil/core";
import { childInputs } from "../../utils/inputBase";
export class TaskAnswerCorrection {
    constructor() {
        this.displayOn = "submit";
        this.showAnswer = false;
        this.preventChanges = false;
        this.displayCorrection = false;
        this.onDisplayEvent = undefined;
    }
    componentWillLoad() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = true;
        }
    }
    handleDisplayUpdate() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = !this.displayCorrection;
        }
        this.display.emit(this.displayCorrection);
    }
    handleDisplay(event) {
        // TODO: This all could be refactored or abandoned
        if (this.onDisplayEvent) {
            let command = this.onDisplayEvent;
            if (command.includes("${visible}")) {
                command = command.replace("${visible}", event.detail.toString());
            }
            eval(command);
        }
    }
    render() {
        return (h(Host, { key: '8941a6c13fcbc1abeb7deb780143d651e92df960', class: this.displayCorrection ? "" : "correction-hidden" }, h("slot", { key: '089b450d018cff137ee2152aa76ce1326436adbe' })));
    }
    static get is() { return "task-answer-correction"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-answer-correction.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-answer-correction.css"]
        };
    }
    static get properties() {
        return {
            "displayOn": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "display-on",
                "reflect": false,
                "defaultValue": "\"submit\""
            },
            "showAnswer": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "show-answer",
                "reflect": false,
                "defaultValue": "false"
            },
            "preventChanges": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "prevent-changes",
                "reflect": false,
                "defaultValue": "false"
            },
            "displayCorrection": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "display-correction",
                "reflect": false,
                "defaultValue": "false"
            },
            "onDisplayEvent": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "on-display-event",
                "reflect": false
            }
        };
    }
    static get events() {
        return [{
                "method": "display",
                "name": "display",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "host"; }
    static get watchers() {
        return [{
                "propName": "displayCorrection",
                "methodName": "handleDisplayUpdate"
            }];
    }
    static get listeners() {
        return [{
                "name": "display",
                "method": "handleDisplay",
                "target": undefined,
                "capture": false,
                "passive": false
            }];
    }
}
//# sourceMappingURL=task-answer-correction.js.map
