import { Host, h } from "@stencil/core";
export class TaskDialog {
    constructor() {
        this.isOpen = true;
        this.headerText = undefined;
        this.isCloseButtonShown = true;
    }
    header() {
        if (this.headerText === null) {
            return null;
        }
        return h("div", { class: "dialog-header" }, h("h6", null, this.headerText), this.isCloseButtonShown &&
            h("task-button", { class: '', icon: 'small-cross', minimal: true, "on-click": () => this.close.emit() }));
    }
    render() {
        return (h(Host, { key: '435f89f7c1bbdfd6e4a7d769086b3188ba9335e8' }, h("task-overlay", { key: '62ef90bf9c4dea6339ca14e7ff1055dfbf983b5b', "is-open": this.isOpen, "has-backdrop": true, "container-class": "overlay-scroll-container" }, h("div", { key: 'b92761e25e40b504a30565a22ff41ede6ee5b562', class: "dialog-container" }, h("div", { key: '80655a05508424eb3d1258bdf6b5409b0b52b7ca', class: "dialog", role: "dialog" }, this.header(), h("slot", { key: '2f09c4ad050f70d26e7faa22c8453dfcf178cc7a' }))))));
    }
    static get is() { return "task-dialog"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-dialog.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-dialog.css"]
        };
    }
    static get properties() {
        return {
            "isOpen": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "is-open",
                "reflect": false,
                "defaultValue": "true"
            },
            "headerText": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "header-text",
                "reflect": false
            },
            "isCloseButtonShown": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "is-close-button-shown",
                "reflect": false,
                "defaultValue": "true"
            }
        };
    }
    static get events() {
        return [{
                "method": "close",
                "name": "close",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "host"; }
}
//# sourceMappingURL=task-dialog.js.map
