import { Host, h } from "@stencil/core";
import { computeBoxLocation } from "../../utils/image";
export class TaskImageBox {
    constructor() {
        this.top = undefined;
        this.left = undefined;
        this.width = undefined;
        this.height = undefined;
        this.coordinates = undefined;
        this.lineWidth = 5;
        this.color = "green";
        this.location = undefined;
    }
    componentWillLoad() {
        this.location = computeBoxLocation(this.left, this.top, this.width, this.height, this.coordinates);
    }
    async drawBox(context, scalar = 1, xOffset = 0, yOffset = 0) {
        if (this.location) {
            const l = this.location.map(x => x * scalar);
            context.beginPath();
            context.lineWidth = this.lineWidth;
            context.strokeStyle = this.color;
            context.rect(l[0] + xOffset, l[1] + yOffset, l[2], l[3]);
            context.stroke();
        }
    }
    /*
    This was a small experiment exploring using calculated lineWidth based on weight and dimensions
    computeWidth(width: number, height: number, weight: number) {
      const minDimension = Math.min(width, height)
      console.log("Min dimension: " + minDimension)
      return 5
    }
     */
    render() {
        return (h(Host, { key: 'b7c45a64669dbbf3fd00e3b4af236e38d7913bad' }, h("slot", { key: '372cd03ff872745f0da33388424ab4ca42971b08' })));
    }
    static get is() { return "task-image-box"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-image-box.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-image-box.css"]
        };
    }
    static get properties() {
        return {
            "top": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "top",
                "reflect": false
            },
            "left": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "left",
                "reflect": false
            },
            "width": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "width",
                "reflect": false
            },
            "height": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "height",
                "reflect": false
            },
            "coordinates": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "coordinates",
                "reflect": false
            },
            "lineWidth": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "line-width",
                "reflect": false,
                "defaultValue": "5"
            },
            "color": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "color",
                "reflect": false,
                "defaultValue": "\"green\""
            }
        };
    }
    static get states() {
        return {
            "location": {}
        };
    }
    static get methods() {
        return {
            "drawBox": {
                "complexType": {
                    "signature": "(context: CanvasRenderingContext2D, scalar?: number, xOffset?: number, yOffset?: number) => Promise<void>",
                    "parameters": [{
                            "name": "context",
                            "type": "CanvasRenderingContext2D",
                            "docs": ""
                        }, {
                            "name": "scalar",
                            "type": "number",
                            "docs": ""
                        }, {
                            "name": "xOffset",
                            "type": "number",
                            "docs": ""
                        }, {
                            "name": "yOffset",
                            "type": "number",
                            "docs": ""
                        }],
                    "references": {
                        "Promise": {
                            "location": "global",
                            "id": "global::Promise"
                        },
                        "CanvasRenderingContext2D": {
                            "location": "global",
                            "id": "global::CanvasRenderingContext2D"
                        }
                    },
                    "return": "Promise<void>"
                },
                "docs": {
                    "text": "",
                    "tags": []
                }
            }
        };
    }
}
//# sourceMappingURL=task-image-box.js.map
