import { h } from "@stencil/core";
export class TaskInstructions {
    constructor() {
        this.tab = "Instructions";
        this.header = "Task Instructions";
        this.open = false;
        this.visible = false;
        this.active = false;
    }
    tabClicked(e) {
        this.open = !this.open;
        e.preventDefault();
    }
    updateActiveVisible(newValue) {
        if (newValue) {
            this.active = true;
            document.documentElement.style.overflow = 'hidden';
            setTimeout(() => this.visible = true, 50);
        }
        else {
            this.visible = false;
            document.documentElement.style.overflow = '';
            setTimeout(() => this.active = false, 350);
        }
    }
    handleKeyDown(ev) {
        if (ev.key === 'Escape') {
            this.open = false;
        }
    }
    /*
    Remaining work:
    * Make the tab button a functional component with its own listener that captures
      the click so it isn't transmitted to the tab bar, then add a close listener to the tabbar
    * Option for left and right
    * Option to set width
    * option to set tab color
    * option to set size
     */
    render() {
        return (h("div", { key: 'ce444468564d5b815e3b7a68a79c6382697bf543', class: "drawer" + (this.visible ? " is-visible" : "") + (this.active ? " is-active" : ""), tabindex: "0" }, h("div", { key: '27af424e705a75eb4505b651c49e62ca433861f1', class: "overlay", tabindex: "-1", onClick: () => this.open = false }), h("div", { key: 'c60d86ec472a9015f619ac6a04dbae0b3c52dcb0', class: "wrapper" }, h("div", { key: 'd709ba6d61022f6a0adc66db95f1ee0d7a1b291f', class: "tabbar" }, h("div", { key: '31108fda56cb05a856defd48e3a79951ebfec0c3', class: "tab", onClick: (e) => this.tabClicked(e) }, h("div", { key: 'ec8144195190bc5fb03b212e4d4af7c993084d83' }, this.tab))), h("div", { key: '1fccfa97d1068e546614206cd009ad2c47a641c4', class: "body" }, h("div", { key: '0ed4c97a7c7e381eb4b67bc172de43b6adee11d3', class: "header" }, h("div", { key: '543bc3c4110173ee665794badf5bc0d39e006e4c', class: "title" }, this.header), h("button", { key: '74185c467c7984ebbdf8b9be8621eab0a8956a7a', class: "close", onClick: () => this.open = false })), h("div", { key: '7db39300b6faf2d3ae0cef5ca96ba31f5ff87957', class: "content" }, h("div", { key: '2ec1563787d11e3cb800fdb9175855fb388c92be', class: "contentSlot" }, h("slot", { key: 'e438fc9635ff700415c4bf2005930e78867cdd70' })))))));
    }
    static get is() { return "task-instructions"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-instructions.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-instructions.css"]
        };
    }
    static get properties() {
        return {
            "tab": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "tab",
                "reflect": false,
                "defaultValue": "\"Instructions\""
            },
            "header": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "header",
                "reflect": false,
                "defaultValue": "\"Task Instructions\""
            }
        };
    }
    static get states() {
        return {
            "open": {},
            "visible": {},
            "active": {}
        };
    }
    static get watchers() {
        return [{
                "propName": "open",
                "methodName": "updateActiveVisible"
            }];
    }
    static get listeners() {
        return [{
                "name": "keydown",
                "method": "handleKeyDown",
                "target": undefined,
                "capture": false,
                "passive": false
            }];
    }
}
//# sourceMappingURL=task-instructions.js.map
