import { Host, h } from "@stencil/core";
export class TaskIterate {
    constructor() {
        this.values = undefined;
    }
    parsedValues() {
        try {
            return JSON.parse(this.values);
        }
        catch (Exception) {
            const values = this.values.replace("[", "").replace("]", "");
            return values.split(",").map(v => v.trim());
        }
    }
    componentWillLoad() {
        this.valueList = this.parsedValues();
        this.elementChildren = this.host.children;
        if (this.elementChildren.length == 1 && "sc-task-iterate" in this.elementChildren.item(0).classList) {
            this.elementChildren = this.elementChildren.item(0).children;
        }
        this.innerHTML = this.host.innerHTML;
    }
    renderChild(value, index) {
        return h("div", { key: `iter${index}`, "data-iterator": value, innerHTML: this.innerHTML, class: "child-container" });
    }
    render() {
        return (h(Host, { key: '27c983ffcd78000786d26a4498897687d5e6b8b8' }, this.valueList.map((value, index) => this.renderChild(value, index)), h("div", { key: 'b11d400cdcaffdb32c90591f5aa65e57c8bd83bb', style: { display: "none" } }, h("slot", { key: '6dfd290ce9ea8df3e0a1551132ea593626c8b55c' }))));
    }
    static get is() { return "task-iterate"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-iterate.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-iterate.css"]
        };
    }
    static get properties() {
        return {
            "values": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "values",
                "reflect": false
            }
        };
    }
    static get elementRef() { return "host"; }
}
//# sourceMappingURL=task-iterate.js.map
