import { Host, h } from "@stencil/core";
export class TaskTag {
    constructor() {
        this.round = undefined;
        this.color = undefined;
        this.removable = undefined;
        this.large = undefined;
        this.small = undefined;
        this.minimal = undefined;
        this.interactive = undefined;
        this.onremove = () => { };
        this.removed = undefined;
    }
    classes() {
        const classList = [];
        if (this.round) {
            classList.push("round");
        }
        if (this.color) {
            classList.push("color-" + this.color);
        }
        if (this.large) {
            classList.push("large");
        }
        if (this.small) {
            classList.push("small");
        }
        if (this.minimal) {
            classList.push("minimal");
        }
        if (this.interactive) {
            classList.push("interactive");
        }
        return classList.join(" ");
    }
    render() {
        return (h(Host, { key: '1b9a5782d2a654bb82e586ffe55b99445a2c6f3d', class: this.classes() }, h("slot", { key: '954ad0c6d782781e1bfce79b19ac4d482df2d9c4' })));
    }
    static get is() { return "task-tag"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-tag.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-tag.css"]
        };
    }
    static get properties() {
        return {
            "round": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "round",
                "reflect": false
            },
            "color": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "color",
                "reflect": false
            },
            "removable": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "removable",
                "reflect": false
            },
            "large": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "large",
                "reflect": false
            },
            "small": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "small",
                "reflect": false
            },
            "minimal": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "minimal",
                "reflect": false
            },
            "interactive": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "interactive",
                "reflect": false
            },
            "onremove": {
                "type": "unknown",
                "mutable": false,
                "complexType": {
                    "original": "() => void",
                    "resolved": "() => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "defaultValue": "() => {}"
            }
        };
    }
    static get states() {
        return {
            "removed": {}
        };
    }
}
//# sourceMappingURL=task-tag.js.map
