import { Host, h } from "@stencil/core";
import { computePosition, autoUpdate, flip, shift, offset } from "@floating-ui/dom";
export class TaskTooltip {
    constructor() {
        this.icon = undefined;
        this.display = false;
    }
    componentDidLoad() {
        this.target.addEventListener("click", this.handleTargetClick.bind(this));
        this.tooltip.addEventListener("click", this.handleTooltipClick.bind(this));
    }
    handleTargetClick() {
        this.display = !this.display;
        if (this.display) {
            this.cleanup = autoUpdate(this.target, this.tooltip, this.updatePosition.bind(this));
        }
        else if (this.cleanup) {
            this.cleanup();
        }
    }
    handleTooltipClick() {
        this.display = false;
    }
    updatePosition() {
        computePosition(this.target, this.tooltip, {
            placement: "bottom-start",
            middleware: [offset(6), flip(), shift({ padding: 5 })]
        }).then(({ x, y }) => {
            Object.assign(this.tooltip.style, {
                left: `${x}px`,
                top: `${y}px`,
            });
        });
    }
    render() {
        return (h(Host, { key: 'c099f41f791eaab5392170b0eaf23dd390e27e6c' }, h("task-icon", { key: '556b3bc1414dc35bc209ca6f285e9c28b784806a', icon: this.icon, ref: el => this.target = el }), h("div", { key: 'f6b050ef8325d21d1f926995c90b21177d5bb9d6', class: "tooltip " + (this.display ? "" : "tooltip-hidden"), ref: el => this.tooltip = el }, h("slot", { key: '3553634da4390a8156dffe6dd540e7a82a1b9bd9' }))));
    }
    static get is() { return "task-tooltip"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["task-tooltip.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["task-tooltip.css"]
        };
    }
    static get properties() {
        return {
            "icon": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "attribute": "icon",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "display": {}
        };
    }
    static get elementRef() { return "host"; }
}
//# sourceMappingURL=task-tooltip.js.map
