import { g as gatherInputOptions, i as inputOptionKeyboardShortcuts, a as ignoreKeypress, b as getAnswerElement, c as getAnswerCorrectionElement } from './utils.js';
import { proxyCustomElement, HTMLElement, createEvent, h, Host, Fragment } from '@stencil/core/internal/client';
import { c as classNames } from './index2.js';
import { d as defineCustomElement$5 } from './task-button2.js';
import { d as defineCustomElement$4 } from './task-button-group2.js';
import { d as defineCustomElement$3 } from './task-icon2.js';
import { d as defineCustomElement$2 } from './task-label2.js';
import { d as defineCustomElement$1 } from './task-tag2.js';

const taskInputCheckboxCss = ".sc-task-input-checkbox-h{display:block}.sc-task-input-checkbox-h{display:block;margin-bottom:0.5rem}label.sc-task-input-checkbox{cursor:pointer;display:block;margin-bottom:10px;position:relative;text-transform:none}label.sc-task-input-checkbox:not(.button){padding-left:26px}label.inline.sc-task-input-checkbox{display:inline-block;margin-right:20px}input.sc-task-input-checkbox{left:0;opacity:0;position:absolute;top:0;z-index:-1}label.sc-task-input-checkbox input.sc-task-input-checkbox:checked~.indicator.sc-task-input-checkbox{background-color:#2d72d2;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2);color:#fff}label.sc-task-input-checkbox:hover input.sc-task-input-checkbox:checked~.indicator.sc-task-input-checkbox{background-color:#215db0}label.sc-task-input-checkbox input.sc-task-input-checkbox:not(:disabled):active:checked~.indicator.sc-task-input-checkbox{background:#184a90}label.sc-task-input-checkbox input.sc-task-input-checkbox:disabled:checked~.indicator.sc-task-input-checkbox{background:rgba(45, 114, 210, 0.5);-webkit-box-shadow:none;box-shadow:none;color:rgba(255, 255, 255, 0.6)}label.sc-task-input-checkbox:not(.labelalign-right){padding-left:26px}label.sc-task-input-checkbox:not(.labelalign-right) .indicator.sc-task-input-checkbox{margin-left:-26px}label.labelalign-right.sc-task-input-checkbox{padding-right:26px}label.labelalign-right.sc-task-input-checkbox .indicator.sc-task-input-checkbox{margin-right:-26px}label.labeldisabled.sc-task-input-checkbox{color:rgba(95, 107, 124, 0.6);cursor:not-allowed}label.labelinline.sc-task-input-checkbox{display:inline-block;margin-right:20px}label.sc-task-input-checkbox input.sc-task-input-checkbox{left:0;opacity:0;position:absolute;top:0;z-index:-1}label.sc-task-input-checkbox .indicator.sc-task-input-checkbox{background-clip:padding-box;background-color:transparent;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));border:none;-webkit-box-shadow:inset 0 0 0 1px #738091;box-shadow:inset 0 0 0 1px #738091;cursor:pointer;display:inline-block;font-size:16px;height:1em;margin-right:10px;margin-top:-3px;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;vertical-align:middle;width:1em}label.sc-task-input-checkbox .indicator.sc-task-input-checkbox::before{content:\"\";display:block;height:1em;width:1em}label.sc-task-input-checkbox:hover .indicator.sc-task-input-checkbox{background-color:rgba(143, 153, 168, 0.15)}label.sc-task-input-checkbox input.sc-task-input-checkbox:not(:disabled):active~.indicator.sc-task-input-checkbox{background:rgba(143, 153, 168, 0.3);-webkit-box-shadow:inset 0 0 0 1px #738091;box-shadow:inset 0 0 0 1px #738091}label.sc-task-input-checkbox input.sc-task-input-checkbox:disabled~.indicator.sc-task-input-checkbox{background:rgba(143, 153, 168, 0.15);-webkit-box-shadow:none;box-shadow:none;cursor:not-allowed}label.sc-task-input-checkbox input.sc-task-input-checkbox:focus~.indicator.sc-task-input-checkbox{outline:rgba(45, 114, 210, 0.6) auto 2px;outline-offset:2px;-moz-outline-radius:6px;outline:#2d72d2 auto 2px}label.labelalign-right.sc-task-input-checkbox .indicator.sc-task-input-checkbox{float:right;margin-left:10px;margin-top:1px}label.labellarge.sc-task-input-checkbox{font-size:16px}label.labellarge.sc-task-input-checkbox:not(.labelalign-right){padding-left:30px}label.labellarge.sc-task-input-checkbox:not(.labelalign-right) .indicator.sc-task-input-checkbox{margin-left:-30px}label.labellarge.labelalign-right.sc-task-input-checkbox{padding-right:30px}label.labellarge.labelalign-right.sc-task-input-checkbox .indicator.sc-task-input-checkbox{margin-right:-30px}label.labellarge.sc-task-input-checkbox .indicator.sc-task-input-checkbox{font-size:20px}label.labellarge.labelalign-right.sc-task-input-checkbox .indicator.sc-task-input-checkbox{margin-top:0}label.sc-task-input-checkbox input.sc-task-input-checkbox:indeterminate~.indicator.sc-task-input-checkbox{background-color:#2d72d2;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2);color:#fff}label.sc-task-input-checkbox:hover input.sc-task-input-checkbox:indeterminate~.indicator.sc-task-input-checkbox{background-color:#215db0}label.sc-task-input-checkbox input.sc-task-input-checkbox:not(:disabled):active:indeterminate~.indicator.sc-task-input-checkbox{background:#184a90}label.sc-task-input-checkbox input.sc-task-input-checkbox:disabled:indeterminate~.indicator.sc-task-input-checkbox{background:rgba(45, 114, 210, 0.5);-webkit-box-shadow:none;box-shadow:none;color:rgba(255, 255, 255, 0.6)}label.sc-task-input-checkbox .indicator.sc-task-input-checkbox{border-radius:3px}label.sc-task-input-checkbox input.sc-task-input-checkbox:checked~.indicator.sc-task-input-checkbox::before{background-image:url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill-rule='evenodd' clip-rule='evenodd' d='M12 5c-.28 0-.53.11-.71.29L7 9.59l-2.29-2.3a1.003 1.003 0 00-1.42 1.42l3 3c.18.18.43.29.71.29s.53-.11.71-.29l5-5A1.003 1.003 0 0012 5z' fill='white'/%3e%3c/svg%3e\")}label.sc-task-input-checkbox input.sc-task-input-checkbox:indeterminate~.indicator.sc-task-input-checkbox::before{background-image:url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill-rule='evenodd' clip-rule='evenodd' d='M11 7H5c-.55 0-1 .45-1 1s.45 1 1 1h6c.55 0 1-.45 1-1s-.45-1-1-1z' fill='white'/%3e%3c/svg%3e\")}.content.sc-task-input-checkbox{display:initial}.content.inline.sc-task-input-checkbox{display:inline-block}.content.sc-task-input-checkbox .tooltipText.sc-task-input-checkbox{visibility:hidden;width:180px;background-color:black;color:#fff;text-align:center;padding:12px;border-radius:6px;position:absolute;top:20px;z-index:100}.content.sc-task-input-checkbox:hover .tooltipText.sc-task-input-checkbox{visibility:visible}";
const TaskInputCheckboxStyle0 = taskInputCheckboxCss;

const TaskInputCheckbox = /*@__PURE__*/ proxyCustomElement(class TaskInputCheckbox extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.inputUpdated = createEvent(this, "inputUpdated", 7);
        this.registerKeyboardShortcut = createEvent(this, "registerKeyboardShortcut", 7);
        this.shortcutMap = new Map();
        this.disconnectedCallback = InputBase.prototype.disconnectedCallback;
        this.formUpdated = InputBase.prototype.formUpdated;
        this.setupDependentInputs = InputBase.prototype.setupDependentInputs;
        this.handleParentElementUpdate = InputBase.prototype.handleParentElementUpdate;
        this.fromInputUpdated = InputBase.prototype.fromInputUpdated.bind(this);
        this.hasAnswerToValidate = () => {
            // TODO: Review why this is different from the others
            return this.answer && this.answerCorrection && true;
        };
        this.name = undefined;
        this.label = undefined;
        this.labelClass = undefined;
        this.required = undefined;
        this.active = undefined;
        this.disabled = undefined;
        this.disableIf = undefined;
        this.requireIf = undefined;
        this.requiredIndicator = undefined;
        this.displayOn = undefined;
        this.displayIf = undefined;
        this.value = undefined;
        this.valueFrom = undefined;
        this.hidden = undefined;
        this.preventChanges = undefined;
        this.answer = undefined;
        this.answerCorrection = undefined;
        this.mode = "checkbox";
        this.inline = undefined;
        this.answerTag = "Answer";
    }
    connectedCallback() {
        InputBase.prototype.connectedCallback.bind(this)();
    }
    async readyToSubmit() { return InputBase.prototype.readyToSubmit.bind(this)(); }
    async setShowCorrections() { return InputBase.prototype.setShowCorrections.bind(this)(); }
    componentWillLoad() {
        InputBase.prototype.componentWillLoad.bind(this)();
        this.options = gatherInputOptions(this.host);
        for (let ks of inputOptionKeyboardShortcuts(this.options)) {
            this.shortcutMap[ks.keys] = ks.value;
            this.registerKeyboardShortcut.emit(ks);
        }
    }
    hasFocus() {
        return document.activeElement === this.host ||
            this.host.contains(document.activeElement) ||
            document.activeElement.contains(this.host);
    }
    keypressHandler(event) {
        if (event.key in this.shortcutMap &&
            this.hasFocus() &&
            !ignoreKeypress() &&
            !this.disabled &&
            !this.preventChanges) {
            const advance = this.value === this.shortcutMap[event.key];
            this.toggleValue(this.shortcutMap[event.key]);
            // If the value does not change as a result of the key press, trigger card advance from here
            if (advance) {
                this.inputUpdated.emit(this.input.form);
            }
            // The following addresses an issue observed with dependent form elements
            // not receiving form updated events when the value is changed via keypress
            this.input.form.elements[this.name].value = this.value;
            this.input.form.dispatchEvent(new InputEvent("input"));
        }
    }
    handleValueUpdate(value) {
        InputBase.prototype.handleValueUpdate.bind(this)(value);
        if (this.answer && this.answerCorrection && this.answerCorrection.displayOn === "mismatch") {
            this.answerCorrection.displayCorrection = (this.answer.value !== value);
        }
        this.input.form.dispatchEvent(new InputEvent("input"));
    }
    async validateAgainstAnswer() {
        // TODO: Review why this is different from the others
        return !(this.hasAnswerToValidate() && this.answerCorrection.displayOn === "submit" && this.value !== this.answer.value);
    }
    onChange(el) {
        this.setValue(el.value, el.checked);
    }
    setValue(value, selected) {
        if (this.value) {
            let arr = JSON.parse(this.value);
            if (selected) {
                arr.push(value);
            }
            else {
                arr = arr.filter(v => v !== value);
            }
            if (arr.length === 0) {
                this.value = null;
            }
            else {
                this.value = JSON.stringify(arr);
            }
        }
        else if (selected) {
            this.value = JSON.stringify([value]);
        }
    }
    toggleValue(value) {
        if (this.value) {
            let arr = JSON.parse(this.value);
            if (!arr.includes(value)) {
                arr.push(value);
            }
            else {
                arr = arr.filter(v => v !== value);
            }
            if (arr.length === 0) {
                this.value = null;
            }
            else {
                this.value = JSON.stringify(arr);
            }
        }
        else {
            this.value = JSON.stringify([value]);
        }
    }
    parsedValue() {
        if (this.value) {
            return JSON.parse(this.value);
        }
        else {
            return [];
        }
    }
    renderCheckbox() {
        return this.options.map(option => h("label", { class: classNames("checkbox", { "inline": this.inline }), key: option.value }, h("input", { type: "checkbox", name: this.name, value: option.value, onChange: e => this.onChange(e.target), checked: this.parsedValue().includes(option.value), disabled: this.disabled || (this.preventChanges && option.value !== this.value), ref: el => this.input = el,
            // Prevents the input getting focus and changing values using arrow keys
            onClick: (e) => e.target.blur() }), h("span", { class: "indicator", key: "indicator" }), h("div", { class: classNames("content", { "inline": this.inline }) }, option.tooltip && h("span", { class: "tooltipText" }, option.tooltip), h("span", { innerHTML: option.innerHTML.trim() })), this.answer &&
            this.answer.value === option.value &&
            (this.answer.showAnswer || (this.answerCorrection.showAnswer &&
                this.answerCorrection.displayCorrection)) &&
            h("task-tag", { round: true, color: "red", small: true, style: { marginLeft: "4px" } }, this.answerTag)));
    }
    renderButtonGroup() {
        return h("task-button-group", null, this.options.map(option => h("task-button", { label: true, class: classNames("checkbox", { "inline": this.inline }), selected: option.value === this.value, onClick: () => this.value = option.value, key: option.value }, h("input", { type: "checkbox", name: this.name, value: option.value, required: this.required, checked: option.value === this.value, disabled: this.disabled || (this.preventChanges && option.value !== this.value), ref: el => this.input = el,
            // Prevents the input getting focus and changing values using arrow keys
            onClick: (e) => e.target.blur() }), h("div", { class: classNames("content", { "inline": this.inline }), innerHTML: option.innerHTML }))));
    }
    render() {
        return (h(Host, { key: 'a5adb62de8ef7925935946fa82715b3cff995392' }, !this.hidden && h(Fragment, { key: 'd5bcb2445bf621dacf9d84f34a463c6bebf6f032' }, this.label && h("task-label", { key: '0e93d557330d05808bb27e54f22dd64be426a623', class: this.labelClass }, this.label), this.mode === "button" ? this.renderButtonGroup() : this.renderCheckbox()), h("slot", { key: '658f6989093503784f3303be65208323aac9fc02' })));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "value": ["handleValueUpdate"]
    }; }
    static get style() { return TaskInputCheckboxStyle0; }
}, [70, "task-input-checkbox", {
        "name": [1],
        "label": [1],
        "labelClass": [1, "label-class"],
        "required": [1028],
        "active": [4],
        "disabled": [1028],
        "disableIf": [1, "disable-if"],
        "requireIf": [1, "require-if"],
        "requiredIndicator": [1, "required-indicator"],
        "displayOn": [1, "display-on"],
        "displayIf": [1, "display-if"],
        "value": [1025],
        "valueFrom": [1, "value-from"],
        "hidden": [1028],
        "mode": [1],
        "inline": [4],
        "answerTag": [1, "answer-tag"],
        "preventChanges": [32],
        "answer": [32],
        "answerCorrection": [32],
        "readyToSubmit": [64],
        "setShowCorrections": [64],
        "validateAgainstAnswer": [64]
    }, [[4, "keypress", "keypressHandler"]], {
        "value": ["handleValueUpdate"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-input-checkbox", "task-button", "task-button-group", "task-icon", "task-label", "task-tag"];
    components.forEach(tagName => { switch (tagName) {
        case "task-input-checkbox":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskInputCheckbox);
            }
            break;
        case "task-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "task-button-group":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "task-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "task-label":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "task-tag":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

function childInputs(parent) {
    return Array.from(parent.querySelectorAll("*")).filter(element => {
        return element.nodeName.startsWith("TASK-INPUT")
            && element.nodeName !== "TASK-INPUT-OPTION";
    });
    /*.filter(element => {
    return element.parentElement.nodeName !== "TASK-ANSWER" ||
      ((element.parentElement as unknown) as TaskAnswer).displayCorrection
  }) as unknown[]) as Input[]*/
}
function requiredChildInputs(parent) {
    return childInputs(parent).filter(input => input.required && !input.disabled && !input.hidden);
}
function inputsWithAnswers() {
    const inputs = Array.from(document.querySelectorAll('*')).filter(element => {
        return element.nodeName.startsWith("TASK-INPUT")
            && element.nodeName !== "TASK-INPUT-OPTION"
            && element.parentElement.nodeName !== "TASK-ANSWER";
    });
    return inputs.filter(element => {
        return Boolean(element.querySelector("TASK-ANSWER"));
    });
}
function getNamedCheckbox(form, name) {
    const el = form.elements.namedItem(name);
    if (el instanceof RadioNodeList) {
        const rnl = el;
        const taskNodes = Array.from(rnl.values()).filter(r => r.nodeName === "TASK-INPUT-CHECKBOX");
        if (taskNodes.length > 0) {
            return taskNodes[0];
        }
        return undefined;
    }
    else if (el instanceof TaskInputCheckbox) {
        return el;
    }
    else {
        return undefined;
    }
}
function evaluateFormula(formula, form) {
    const operators = ["=", " in ", " IN ", " In ", "!=", "<=", ">=", "<", ">"];
    let operator = null;
    let parts = null;
    let not = false;
    let any = false;
    if (formula.startsWith("not(") && formula.endsWith(")")) {
        not = true;
        formula = formula.substring(4, formula.length - 1);
    }
    for (let op of operators) {
        if (formula.includes(op)) {
            operator = op.toLowerCase().trim();
            parts = formula.split(op).map(p => p.trim());
            break;
        }
    }
    if (parts) {
        if (operator === "in") {
            const cb = getNamedCheckbox(form, parts[1]);
            if (cb) {
                const value = cb.value;
                if (value) {
                    const evaluation = evaluateOperator(operator, [parts[0]], value);
                    const success = evaluation.filter(e => e);
                    return success.length > 0;
                }
                return false;
            }
        }
        const inputNames = getFormulaInputNames(parts[0]);
        any = inputNames.length > 1 && parts[0].startsWith("any");
        const values = inputNames.map(name => form.elements[name] && form.elements[name].value);
        const evaluation = evaluateOperator(operator, values, parts[1]);
        const success = evaluation.filter(e => e);
        const evalTrue = success.length === inputNames.length || (any && success.length > 0);
        return (evalTrue && !not) || (!evalTrue && not);
    }
}
function evaluateOperator(op, values, formulaSuffix) {
    switch (op) {
        case "=":
            return values.map(v => v === formulaSuffix);
        case "!=":
            return values.map(v => v !== formulaSuffix);
        case ">":
            return values.map(v => parseFloat(v) > parseFloat(formulaSuffix));
        case ">=":
            return values.map(v => parseFloat(v) >= parseFloat(formulaSuffix));
        case "<":
            return values.map(v => parseFloat(v) < parseFloat(formulaSuffix));
        case "<=":
            return values.map(v => parseFloat(v) <= parseFloat(formulaSuffix));
        case "in":
            if (formulaSuffix.startsWith("[") && formulaSuffix.endsWith("]") && formulaSuffix.length > 2) {
                formulaSuffix = formulaSuffix.substring(1, formulaSuffix.length - 1);
                const options = formulaSuffix.split(",").map(o => trimQuotes(o.trim()));
                return values.map(v => options.includes(v));
            }
            else {
                return [];
            }
    }
}
function trimQuotes(value) {
    if ((value.startsWith("'") && value.endsWith("'")) || (value.startsWith('"') && value.endsWith('"'))) {
        return value.substring(1, value.length - 1);
    }
    else {
        return value;
    }
}
function getFormulaInputNames(formulaPrefix) {
    const functions = ["any", "all"];
    for (let f of functions) {
        if (formulaPrefix.startsWith(f)) {
            return formulaPrefix.substring(4, formulaPrefix.length - 1).split(",").map(i => i.trim());
        }
    }
    return [formulaPrefix];
}
function getFormElement(host) {
    let el = host;
    while (el) {
        if (el.tagName === "FORM") {
            return el;
        }
        el = el.parentElement;
        if (el.tagName === "BODY") {
            return undefined;
        }
    }
}
function findInput(name) {
    return new Promise(resolve => {
        const input = document.querySelector(`[name='${name}']`);
        if (input) {
            resolve(input);
        }
        else {
            setTimeout(() => resolve(findInput(name)), 1000);
        }
    });
}
function attachInputListener(name, callback, type = "inputUpdated") {
    return findInput(name).then((input) => {
        input.addEventListener(type, callback);
        return input;
    });
}
class InputBase {
    constructor() {
        this.hasAnswerToValidate = () => {
            return this.answer && this.answerCorrection && this.answerCorrection.displayOn === "submit";
        };
    }
    /***
     Lifecycle methods
     */
    componentWillLoad() {
        this.answer = getAnswerElement(this.host);
        this.answerCorrection = getAnswerCorrectionElement(this.host);
    }
    connectedCallback() {
        this.form = getFormElement(this.host);
        if (this.requireIf || this.displayIf || this.disableIf || this.valueFrom) {
            if (['loaded', 'interactive', 'complete'].includes(document.readyState)) {
                this.setupDependentInputs();
            }
            else {
                this.loadCallback = this.setupDependentInputs.bind(this);
                document.addEventListener("load", this.setupDependentInputs);
            }
        }
        // TODO: Modify the check to better check for input type
        if (this.displayOn && this.host.parentElement.tagName.startsWith("TASK-INPUT")) {
            this.handleParentElementUpdate();
            this.displayOnCallback = this.handleParentElementUpdate.bind(this);
            this.host.parentElement.addEventListener("inputUpdated", this.displayOnCallback);
        }
    }
    disconnectedCallback() {
        if (this.loadCallback) {
            document.removeEventListener("load", this.loadCallback);
        }
        if (this.formCallback) {
            this.form.removeEventListener("input", this.formCallback);
        }
        if (this.displayOnCallback) {
            this.host.parentElement.removeEventListener("inputUpdated", this.displayOnCallback);
        }
    }
    formUpdated() {
        if (this.form) {
            if (this.requireIf) {
                const result = evaluateFormula(this.requireIf, this.form);
                if (result !== undefined) {
                    this.required = result;
                }
            }
            if (this.displayIf) {
                const result = evaluateFormula(this.displayIf, this.form);
                if (result !== undefined) {
                    const previous = this.hidden;
                    this.hidden = !result;
                    if (this.hidden !== previous) {
                        this.inputUpdated.emit(this.form);
                    }
                }
            }
            if (this.disableIf) {
                const result = evaluateFormula(this.disableIf, this.form);
                if (result !== undefined) {
                    const previous = this.disabled;
                    this.disabled = result;
                    if (this.disabled !== previous) {
                        this.inputUpdated.emit(this.form);
                    }
                }
            }
        }
    }
    setupDependentInputs() {
        if ((this.requireIf || this.displayIf || this.disableIf) && this.form) {
            this.formCallback = this.formUpdated.bind(this);
            this.form.addEventListener('input', this.formCallback);
            this.formUpdated();
        }
        if (this.valueFrom) {
            attachInputListener(this.valueFrom, this.fromInputUpdated)
                .then(input => {
                this.fromInput = input;
                this.fromInputUpdated();
            });
        }
    }
    fromInputUpdated() {
        if (this.fromInput) {
            this.value = this.fromInput.value;
        }
    }
    handleParentElementUpdate() {
        const parent = this.host.parentElement;
        const previous = this.hidden;
        this.hidden = parent.value !== this.displayOn || parent.hidden;
        if (this.hidden !== previous) {
            this.inputUpdated.emit(this.form);
        }
    }
    //@Method()
    async readyToSubmit() {
        return Boolean(this.value);
    }
    //Method()
    async validateAgainstAnswer() {
        return !(this.hasAnswerToValidate() && this.value !== this.answer.value);
    }
    //@Method()
    async setShowCorrections(value) {
        if (this.hasAnswerToValidate()) {
            this.preventChanges = this.answerCorrection.preventChanges && value;
            if (this.value !== this.answer.value) {
                this.answerCorrection.displayCorrection = value;
                if (value) {
                    this.inputUpdated.emit(this.form);
                }
            }
        }
    }
    //@Watch("value")
    //@Watch("required")
    handleValueUpdate(_value) {
        this.inputUpdated.emit(this.form);
    }
    displayOnCallback(_ev) { }
    formCallback(_ev) { }
    loadCallback(_ev) { }
}

export { InputBase as I, TaskInputCheckbox as T, attachInputListener as a, childInputs as c, defineCustomElement as d, evaluateFormula as e, getFormElement as g, inputsWithAnswers as i, requiredChildInputs as r };

//# sourceMappingURL=inputBase.js.map