import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { c as childInputs } from './inputBase.js';

const taskAnswerCorrectionCss = ".sc-task-answer-correction-h{display:block}.correction-hidden.sc-task-answer-correction-h{display:none}";
const TaskAnswerCorrectionStyle0 = taskAnswerCorrectionCss;

const TaskAnswerCorrection$1 = /*@__PURE__*/ proxyCustomElement(class TaskAnswerCorrection extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.display = createEvent(this, "display", 7);
        this.displayOn = "submit";
        this.showAnswer = false;
        this.preventChanges = false;
        this.displayCorrection = false;
        this.onDisplayEvent = undefined;
    }
    componentWillLoad() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = true;
        }
    }
    handleDisplayUpdate() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = !this.displayCorrection;
        }
        this.display.emit(this.displayCorrection);
    }
    handleDisplay(event) {
        // TODO: This all could be refactored or abandoned
        if (this.onDisplayEvent) {
            let command = this.onDisplayEvent;
            if (command.includes("${visible}")) {
                command = command.replace("${visible}", event.detail.toString());
            }
            eval(command);
        }
    }
    render() {
        return (h(Host, { key: '8941a6c13fcbc1abeb7deb780143d651e92df960', class: this.displayCorrection ? "" : "correction-hidden" }, h("slot", { key: '089b450d018cff137ee2152aa76ce1326436adbe' })));
    }
    get host() { return this; }
    static get watchers() { return {
        "displayCorrection": ["handleDisplayUpdate"]
    }; }
    static get style() { return TaskAnswerCorrectionStyle0; }
}, [6, "task-answer-correction", {
        "displayOn": [1, "display-on"],
        "showAnswer": [4, "show-answer"],
        "preventChanges": [4, "prevent-changes"],
        "displayCorrection": [4, "display-correction"],
        "onDisplayEvent": [1, "on-display-event"]
    }, [[0, "display", "handleDisplay"]], {
        "displayCorrection": ["handleDisplayUpdate"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-answer-correction"];
    components.forEach(tagName => { switch (tagName) {
        case "task-answer-correction":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskAnswerCorrection$1);
            }
            break;
    } });
}

const TaskAnswerCorrection = TaskAnswerCorrection$1;
const defineCustomElement = defineCustomElement$1;

export { TaskAnswerCorrection, defineCustomElement };

//# sourceMappingURL=task-answer-correction.js.map