import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const taskCalloutCss = ".sc-task-callout-h{display:block}.sc-task-callout-h{font-size:14px;line-height:1.5;background-color:rgba(143, 153, 168, 0.15);border-radius:3px;padding:10px 12px 9px;position:relative;width:100%;-webkit-box-sizing:border-box;box-sizing:border-box}.sc-task-callout-h .heading.sc-task-callout{line-height:20px;margin-bottom:5px;margin-top:0}.sc-task-callout-h .heading.sc-task-callout:last-child{margin-bottom:0}.intent-primary.sc-task-callout-h{background-color:rgba(45, 114, 210, 0.15)}.intent-primary.sc-task-callout-h .heading.sc-task-callout{color:#215db0}.intent-success.sc-task-callout-h{background-color:rgba(35, 133, 81, 0.15)}.intent-success.sc-task-callout-h .heading.sc-task-callout{color:#1c6e42}.intent-warning.sc-task-callout-h{background-color:rgba(200, 118, 25, 0.15)}.intent-warning.sc-task-callout-h .heading.sc-task-callout{color:#935610}.intent-danger.sc-task-callout-h{background-color:rgba(205, 66, 70, 0.15)}.intent-danger.sc-task-callout-h .heading.sc-task-callout{color:#ac2f33}.sc-task-callout-h{background-color:rgba(143, 153, 168, 0.15)}.intent-primary.sc-task-callout-h{background-color:rgba(45, 114, 210, 0.1)}.intent-success.sc-task-callout-h{background-color:rgba(35, 133, 81, 0.1)}.intent-warning.sc-task-callout-h{background-color:rgba(200, 118, 25, 0.1)}.intent-danger.sc-task-callout-h{background-color:rgba(205, 66, 70, 0.1)}";
const TaskCalloutStyle0 = taskCalloutCss;

const TaskCallout$1 = /*@__PURE__*/ proxyCustomElement(class TaskCallout extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.intent = undefined;
    }
    render() {
        return (h(Host, { key: 'fe1766260518a4e441e3d3a414924af05b1c86fc', class: this.intent ? "intent-" + this.intent : null }, h("slot", { key: '958677ce22b112ab7f9c66aae0a313a222436556' })));
    }
    static get style() { return TaskCalloutStyle0; }
}, [6, "task-callout", {
        "intent": [1]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-callout"];
    components.forEach(tagName => { switch (tagName) {
        case "task-callout":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskCallout$1);
            }
            break;
    } });
}

const TaskCallout = TaskCallout$1;
const defineCustomElement = defineCustomElement$1;

export { TaskCallout, defineCustomElement };

//# sourceMappingURL=task-callout.js.map