import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$3 } from './task-button2.js';
import { d as defineCustomElement$2 } from './task-icon2.js';

const taskCopyableCss = ":host{display:inline}";
const TaskCopyableStyle0 = taskCopyableCss;

const TaskCopyable$1 = /*@__PURE__*/ proxyCustomElement(class TaskCopyable extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
    }
    handleClick() {
        navigator.clipboard.writeText(this.host.innerText).then();
    }
    render() {
        return (h(Host, { key: '11b401c9ea39b77b5669fe3a45b6778b098d30d3' }, h("slot", { key: '33c211e755042f0eb494cbe55e6d126922ba6f8f' }), h("task-button", { key: '5ca549ab45165597778e61fb2a2b52f8ffd53277', icon: "duplicate", minimal: true, small: true, "icon-size": 12, onClick: () => this.handleClick() })));
    }
    get host() { return this; }
    static get style() { return TaskCopyableStyle0; }
}, [4, "task-copyable"]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-copyable", "task-button", "task-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "task-copyable":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskCopyable$1);
            }
            break;
        case "task-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "task-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}

const TaskCopyable = TaskCopyable$1;
const defineCustomElement = defineCustomElement$1;

export { TaskCopyable, defineCustomElement };

//# sourceMappingURL=task-copyable.js.map