import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$4 } from './task-button2.js';
import { d as defineCustomElement$3 } from './task-icon2.js';
import { d as defineCustomElement$2 } from './task-overlay2.js';

const taskDialogCss = ".sc-task-dialog-h{display:block}.dialog-container.sc-task-dialog{opacity:1;-webkit-transform:scale(1);transform:scale(1);-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;min-height:100%;pointer-events:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;width:100%}.dialog.sc-task-dialog{background:#f6f7f9;border-radius:4px;-webkit-box-shadow:0 0 0 1px rgba(17, 20, 24, 0.1), 0 2px 4px rgba(17, 20, 24, 0.2), 0 8px 24px rgba(17, 20, 24, 0.2);box-shadow:0 0 0 1px rgba(17, 20, 24, 0.1), 0 2px 4px rgba(17, 20, 24, 0.2), 0 8px 24px rgba(17, 20, 24, 0.2);display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;margin:30px 0;pointer-events:all;-webkit-user-select:text;-moz-user-select:text;-ms-user-select:text;user-select:text;width:500px}.dialog.sc-task-dialog:focus{outline:0}.dialog.dark.sc-task-dialog,.dark.sc-task-dialog .dialog.sc-task-dialog{background:#252a31;-webkit-box-shadow:inset 0 0 0 1px rgba(255, 255, 255, 0.2), 0 2px 4px rgba(17, 20, 24, 0.4), 0 8px 24px rgba(17, 20, 24, 0.4);box-shadow:inset 0 0 0 1px rgba(255, 255, 255, 0.2), 0 2px 4px rgba(17, 20, 24, 0.4), 0 8px 24px rgba(17, 20, 24, 0.4);color:#f6f7f9}@media (forced-colors: active) and (prefers-color-scheme: dark){.dialog.sc-task-dialog{border:1px solid buttonborder}}.dialog-header.sc-task-dialog{-ms-flex-align:center;align-items:center;background:#ffffff;border-radius:4px 4px 0 0;-webkit-box-shadow:0 1px 0 rgba(17, 20, 24, 0.15);box-shadow:0 1px 0 rgba(17, 20, 24, 0.15);display:-ms-flexbox;display:flex;-ms-flex:0 0 auto;flex:0 0 auto;min-height:40px;padding:5px;padding-left:15px;z-index:0}.dialog-header.sc-task-dialog .icon-large.sc-task-dialog,.dialog-header.sc-task-dialog .icon.sc-task-dialog{color:#5f6b7c;-ms-flex:0 0 auto;flex:0 0 auto;margin-left:-3px;margin-right:7.5px}.dialog-header.sc-task-dialog .heading.sc-task-dialog{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;word-wrap:normal;-ms-flex:1 1 auto;flex:1 1 auto;line-height:inherit;margin:0}.dialog-header.sc-task-dialog .heading.sc-task-dialog:last-child{margin-right:15px}.dark.sc-task-dialog .dialog-header.sc-task-dialog{background:#2f343c;-webkit-box-shadow:inset 0 0 0 1px rgba(255, 255, 255, 0.2);box-shadow:inset 0 0 0 1px rgba(255, 255, 255, 0.2)}.dark.sc-task-dialog .dialog-header.sc-task-dialog .icon-large.sc-task-dialog,.dark.sc-task-dialog .dialog-header.sc-task-dialog .icon.sc-task-dialog{color:#abb3bf}@media (forced-colors: active) and (prefers-color-scheme: dark){.dialog-header.sc-task-dialog{border-bottom:1px solid buttonborder}}.dialog-body.sc-task-dialog{-ms-flex:1 1 auto;flex:1 1 auto;margin:15px}.dialog-body-scroll-container.sc-task-dialog{margin:0;max-height:70vh;overflow:auto;padding:15px}.dialog-footer.sc-task-dialog{-ms-flex:0 0 auto;flex:0 0 auto;margin:15px}.dialog-footer-fixed.sc-task-dialog{-ms-flex-align:center;align-items:center;background-color:#ffffff;border-radius:0 0 4px 4px;border-top:1px solid rgba(17, 20, 24, 0.15);display:-ms-flexbox;display:flex;gap:15px;-ms-flex-pack:justify;justify-content:space-between;margin:0;padding:10px 10px 10px 15px}.dark.sc-task-dialog .dialog-footer-fixed.sc-task-dialog{background:#383e47;border-top:1px solid rgba(255, 255, 255, 0.2)}.dialog-footer-main-section.sc-task-dialog{-ms-flex:1 0 auto;flex:1 0 auto}.dialog-footer-actions.sc-task-dialog{display:-ms-flexbox;display:flex;-ms-flex-pack:end;justify-content:flex-end}.dialog-footer-actions.sc-task-dialog .button.sc-task-dialog{margin-left:10px}.multistep-dialog-panels.sc-task-dialog{display:-ms-flexbox;display:flex}.multistep-dialog-panels.sc-task-dialog:first-child .dialog-step-container.sc-task-dialog:first-child{border-radius:4px 0 0 0}.multistep-dialog-panels.sc-task-dialog:first-child .multistep-dialog-right-panel.sc-task-dialog{border-top-right-radius:4px}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog{-ms-flex-direction:column;flex-direction:column}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog:first-child .dialog-step-container.sc-task-dialog:first-child{border-radius:4px 0 0 0}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog:first-child .dialog-step-container.sc-task-dialog:last-child{border-radius:0 4px 0 0}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-left-panel.sc-task-dialog{-ms-flex-direction:row;flex-direction:row}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .dialog-step-container.sc-task-dialog{-ms-flex-positive:1;flex-grow:1}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .dialog-step-container.sc-task-dialog:not(:first-child){border-left:1px solid rgba(17, 20, 24, 0.15)}.dark.sc-task-dialog .multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .dialog-step-container.sc-task-dialog{border-color:rgba(17, 20, 24, 0.4)}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-right-panel.sc-task-dialog{border-left:none}.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-right-panel.sc-task-dialog,.multistep-dialog-nav-top.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-footer.sc-task-dialog{border-radius:0 0 4px 4px}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog{-ms-flex-direction:row-reverse;flex-direction:row-reverse}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog:first-child .multistep-dialog-right-panel.sc-task-dialog{border-radius:4px 0 0 4px}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog:first-child .dialog-step-container.sc-task-dialog:first-child{border-radius:0 4px 0 0}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-left-panel.sc-task-dialog{border-radius:0 0 4px 0}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-right-panel.sc-task-dialog{border-left:none;border-radius:4px 0 0 4px;border-right:1px solid rgba(17, 20, 24, 0.15)}.dark.sc-task-dialog .multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .multistep-dialog-right-panel.sc-task-dialog{border-color:rgba(17, 20, 24, 0.4)}.multistep-dialog-nav-right.sc-task-dialog .multistep-dialog-panels.sc-task-dialog .dialog-footer.sc-task-dialog{border-bottom-left-radius:0}.multistep-dialog-left-panel.sc-task-dialog{display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;-ms-flex-direction:column;flex-direction:column}.dark.sc-task-dialog .multistep-dialog-left-panel.sc-task-dialog{background:#252a31;border-bottom:1px solid rgba(255, 255, 255, 0.2);border-bottom-left-radius:4px;border-left:1px solid rgba(255, 255, 255, 0.2)}.multistep-dialog-right-panel.sc-task-dialog{background-color:#f6f7f9;border-left:1px solid rgba(17, 20, 24, 0.15);border-radius:0 0 4px 0;-ms-flex:3;flex:3;min-width:0}.dark.sc-task-dialog .multistep-dialog-right-panel.sc-task-dialog{background-color:#2f343c;border-bottom:1px solid rgba(255, 255, 255, 0.2);border-bottom-right-radius:4px;border-left:1px solid rgba(255, 255, 255, 0.2);border-right:1px solid rgba(255, 255, 255, 0.2)}.dialog-step-container.sc-task-dialog{background-color:#f6f7f9;border-bottom:1px solid rgba(17, 20, 24, 0.15)}.dark.sc-task-dialog .dialog-step-container.sc-task-dialog{background:#2f343c;border-bottom:1px solid rgba(255, 255, 255, 0.2)}.dialog-step-container.dialog-step-viewed.sc-task-dialog{background-color:#ffffff}.dark.sc-task-dialog .dialog-step-container.dialog-step-viewed.sc-task-dialog{background:#383e47}.dialog-step.sc-task-dialog{-ms-flex-align:center;align-items:center;border-radius:4px;cursor:not-allowed;display:-ms-flexbox;display:flex;margin:4px;padding:6px 14px}.dark.sc-task-dialog .dialog-step.sc-task-dialog{background:#2f343c}.dialog-step-viewed.sc-task-dialog .dialog-step.sc-task-dialog{background-color:#ffffff;cursor:pointer}.dark.sc-task-dialog .dialog-step-viewed.sc-task-dialog .dialog-step.sc-task-dialog{background:#383e47}.dialog-step.sc-task-dialog:hover{background-color:#f6f7f9}.dark.sc-task-dialog .dialog-step.sc-task-dialog:hover{background:#2f343c}.dialog-step-icon.sc-task-dialog{-ms-flex-align:center;align-items:center;background-color:rgba(95, 107, 124, 0.6);border-radius:50%;color:#ffffff;display:-ms-flexbox;display:flex;height:25px;-ms-flex-pack:center;justify-content:center;width:25px}.dark.sc-task-dialog .dialog-step-icon.sc-task-dialog{background-color:rgba(171, 179, 191, 0.6)}.active.dialog-step-viewed.sc-task-dialog .dialog-step-icon.sc-task-dialog{background-color:#4c90f0}.dialog-step-viewed.sc-task-dialog .dialog-step-icon.sc-task-dialog{background-color:#8f99a8}.dialog-step-title.sc-task-dialog{color:rgba(95, 107, 124, 0.6);-ms-flex:1;flex:1;padding-left:10px}.dark.sc-task-dialog .dialog-step-title.sc-task-dialog{color:rgba(171, 179, 191, 0.6)}.active.dialog-step-viewed.sc-task-dialog .dialog-step-title.sc-task-dialog{color:#4c90f0}.dialog-step-viewed.sc-task-dialog:not(.active) .dialog-step-title.sc-task-dialog{color:#1c2127}.dark.sc-task-dialog .dialog-step-viewed.sc-task-dialog:not(.active) .dialog-step-title.sc-task-dialog{color:#f6f7f9}";
const TaskDialogStyle0 = taskDialogCss;

const TaskDialog$1 = /*@__PURE__*/ proxyCustomElement(class TaskDialog extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.close = createEvent(this, "close", 7);
        this.isOpen = true;
        this.headerText = undefined;
        this.isCloseButtonShown = true;
    }
    header() {
        if (this.headerText === null) {
            return null;
        }
        return h("div", { class: "dialog-header" }, h("h6", null, this.headerText), this.isCloseButtonShown &&
            h("task-button", { class: '', icon: 'small-cross', minimal: true, "on-click": () => this.close.emit() }));
    }
    render() {
        return (h(Host, { key: '435f89f7c1bbdfd6e4a7d769086b3188ba9335e8' }, h("task-overlay", { key: '62ef90bf9c4dea6339ca14e7ff1055dfbf983b5b', "is-open": this.isOpen, "has-backdrop": true, "container-class": "overlay-scroll-container" }, h("div", { key: 'b92761e25e40b504a30565a22ff41ede6ee5b562', class: "dialog-container" }, h("div", { key: '80655a05508424eb3d1258bdf6b5409b0b52b7ca', class: "dialog", role: "dialog" }, this.header(), h("slot", { key: '2f09c4ad050f70d26e7faa22c8453dfcf178cc7a' }))))));
    }
    get host() { return this; }
    static get style() { return TaskDialogStyle0; }
}, [6, "task-dialog", {
        "isOpen": [4, "is-open"],
        "headerText": [1, "header-text"],
        "isCloseButtonShown": [4, "is-close-button-shown"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-dialog", "task-button", "task-icon", "task-overlay"];
    components.forEach(tagName => { switch (tagName) {
        case "task-dialog":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskDialog$1);
            }
            break;
        case "task-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "task-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "task-overlay":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}

const TaskDialog = TaskDialog$1;
const defineCustomElement = defineCustomElement$1;

export { TaskDialog, defineCustomElement };

//# sourceMappingURL=task-dialog.js.map