import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as computeBoxLocation } from './image.js';

const taskImageBoxCss = ".sc-task-image-box-h{display:none}";
const TaskImageBoxStyle0 = taskImageBoxCss;

const TaskImageBox$1 = /*@__PURE__*/ proxyCustomElement(class TaskImageBox extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.top = undefined;
        this.left = undefined;
        this.width = undefined;
        this.height = undefined;
        this.coordinates = undefined;
        this.lineWidth = 5;
        this.color = "green";
        this.location = undefined;
    }
    componentWillLoad() {
        this.location = computeBoxLocation(this.left, this.top, this.width, this.height, this.coordinates);
    }
    async drawBox(context, scalar = 1, xOffset = 0, yOffset = 0) {
        if (this.location) {
            const l = this.location.map(x => x * scalar);
            context.beginPath();
            context.lineWidth = this.lineWidth;
            context.strokeStyle = this.color;
            context.rect(l[0] + xOffset, l[1] + yOffset, l[2], l[3]);
            context.stroke();
        }
    }
    /*
    This was a small experiment exploring using calculated lineWidth based on weight and dimensions
    computeWidth(width: number, height: number, weight: number) {
      const minDimension = Math.min(width, height)
      console.log("Min dimension: " + minDimension)
      return 5
    }
     */
    render() {
        return (h(Host, { key: 'b7c45a64669dbbf3fd00e3b4af236e38d7913bad' }, h("slot", { key: '372cd03ff872745f0da33388424ab4ca42971b08' })));
    }
    static get style() { return TaskImageBoxStyle0; }
}, [6, "task-image-box", {
        "top": [2],
        "left": [2],
        "width": [2],
        "height": [2],
        "coordinates": [1],
        "lineWidth": [2, "line-width"],
        "color": [1],
        "location": [32],
        "drawBox": [64]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-image-box"];
    components.forEach(tagName => { switch (tagName) {
        case "task-image-box":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskImageBox$1);
            }
            break;
    } });
}

const TaskImageBox = TaskImageBox$1;
const defineCustomElement = defineCustomElement$1;

export { TaskImageBox, defineCustomElement };

//# sourceMappingURL=task-image-box.js.map