import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { I as InputBase } from './inputBase.js';
import { g as gatherInputOptions, i as inputOptionKeyboardShortcuts, a as ignoreKeypress } from './utils.js';

const taskInputSelectCss = ".sc-task-input-select-h{display:block}label.sc-task-input-select{display:block;margin-bottom:15px;margin-top:0}label.sc-task-input-select .html-select.sc-task-input-select,label.sc-task-input-select .input.sc-task-input-select,label.sc-task-input-select .select.sc-task-input-select{display:block;margin-top:5px;text-transform:none}label.sc-task-input-select .select.sc-task-input-select select.sc-task-input-select,label.sc-task-input-select .html-select.sc-task-input-select select.sc-task-input-select{font-weight:400;vertical-align:top;width:100%}label.disabled.sc-task-input-select{color:rgba(95, 107, 124, 0.6)}label.label.inline.sc-task-input-select{line-height:30px}label.inline.sc-task-input-select .input.sc-task-input-select,label.inline.sc-task-input-select .select.sc-task-input-select{display:inline-block;margin:0 0 0 5px;vertical-align:top}.select.sc-task-input-select select.sc-task-input-select{display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border:none;border-radius:3px;cursor:pointer;font-size:14px;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;text-align:left;vertical-align:middle;background-color:#f6f7f9;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);color:#1c2127;-moz-appearance:none;-webkit-appearance:none;border-radius:3px;height:30px;-webkit-box-sizing:border-box;box-sizing:border-box;padding:0 25px 0 10px;width:100%}.select.sc-task-input-select select.sc-task-input-select>*.sc-task-input-select{-webkit-box-flex:0;-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0}.select.sc-task-input-select select.sc-task-input-select>.fill.sc-task-input-select{-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:1;flex-shrink:1}.select.sc-task-input-select select.sc-task-input-select::before,.select.sc-task-input-select select.sc-task-input-select>*.sc-task-input-select{margin-right:7px}.select.sc-task-input-select select.sc-task-input-select:empty::before,.select.sc-task-input-select select.sc-task-input-select>.sc-task-input-select:last-child{margin-right:0}.select.sc-task-input-select select.sc-task-input-select:hover{background-clip:padding-box;background-color:#edeff2;-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1)}.select.sc-task-input-select select.sc-task-input-select:active,.select.sc-task-input-select select.active.sc-task-input-select{background-color:#dce0e5;background-image:none;-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 1px 2px rgba(17, 20, 24, 0.2);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 1px 2px rgba(17, 20, 24, 0.2)}.select.sc-task-input-select select.sc-task-input-select:disabled,.select.sc-task-input-select select.disabled.sc-task-input-select{background-color:rgba(211, 216, 222, 0.5);background-image:none;-webkit-box-shadow:none;box-shadow:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed;outline:none}.select.sc-task-input-select select.sc-task-input-select:disabled.active,.select.sc-task-input-select select.disabled.active.sc-task-input-select{background:rgba(211, 216, 222, 0.7)}.select.minimal.sc-task-input-select select.sc-task-input-select{background:none;-webkit-box-shadow:none;box-shadow:none}.select.minimal.sc-task-input-select select.sc-task-input-select:hover{background:rgba(143, 153, 168, 0.15);-webkit-box-shadow:none;box-shadow:none;color:#1c2127;text-decoration:none}.select.minimal.sc-task-input-select select.sc-task-input-select:active,.select.minimal.sc-task-input-select select.active.sc-task-input-select{background:rgba(143, 153, 168, 0.3);-webkit-box-shadow:none;box-shadow:none;color:#1c2127}.select.minimal.sc-task-input-select select.sc-task-input-select:disabled,.select.minimal.sc-task-input-select select.disabled.sc-task-input-select{background:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed}.select.minimal.sc-task-input-select select.sc-task-input-select:disabled.active,.select.minimal.sc-task-input-select select.disabled.active.sc-task-input-select{background:rgba(143, 153, 168, 0.3)}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select{color:#215db0}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:hover,.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-primary.active.sc-task-input-select{background:none;-webkit-box-shadow:none;box-shadow:none;color:#215db0}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:hover{background:rgba(45, 114, 210, 0.15);color:#215db0}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-primary.active.sc-task-input-select{background:rgba(45, 114, 210, 0.3);color:#215db0}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:disabled,.select.minimal.sc-task-input-select select.intent-primary.disabled.sc-task-input-select{background:none;color:rgba(33, 93, 176, 0.5)}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select:disabled.active,.select.minimal.sc-task-input-select select.intent-primary.disabled.active.sc-task-input-select{background:rgba(45, 114, 210, 0.3)}.select.minimal.sc-task-input-select select.intent-primary.sc-task-input-select .button-spinner.sc-task-input-select .spinner-head.sc-task-input-select{stroke:#215db0}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select{color:#1c6e42}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:hover,.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-success.active.sc-task-input-select{background:none;-webkit-box-shadow:none;box-shadow:none;color:#1c6e42}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:hover{background:rgba(35, 133, 81, 0.15);color:#1c6e42}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-success.active.sc-task-input-select{background:rgba(35, 133, 81, 0.3);color:#1c6e42}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:disabled,.select.minimal.sc-task-input-select select.intent-success.disabled.sc-task-input-select{background:none;color:rgba(28, 110, 66, 0.5)}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select:disabled.active,.select.minimal.sc-task-input-select select.intent-success.disabled.active.sc-task-input-select{background:rgba(35, 133, 81, 0.3)}.select.minimal.sc-task-input-select select.intent-success.sc-task-input-select .button-spinner.sc-task-input-select .spinner-head.sc-task-input-select{stroke:#1c6e42}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select{color:#935610}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:hover,.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-warning.active.sc-task-input-select{background:none;-webkit-box-shadow:none;box-shadow:none;color:#935610}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:hover{background:rgba(200, 118, 25, 0.15);color:#935610}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-warning.active.sc-task-input-select{background:rgba(200, 118, 25, 0.3);color:#935610}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:disabled,.select.minimal.sc-task-input-select select.intent-warning.disabled.sc-task-input-select{background:none;color:rgba(147, 86, 16, 0.5)}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select:disabled.active,.select.minimal.sc-task-input-select select.intent-warning.disabled.active.sc-task-input-select{background:rgba(200, 118, 25, 0.3)}.select.minimal.sc-task-input-select select.intent-warning.sc-task-input-select .button-spinner.sc-task-input-select .spinner-head.sc-task-input-select{stroke:#935610}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select{color:#ac2f33}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:hover,.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-danger.active.sc-task-input-select{background:none;-webkit-box-shadow:none;box-shadow:none;color:#ac2f33}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:hover{background:rgba(205, 66, 70, 0.15);color:#ac2f33}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:active,.select.minimal.sc-task-input-select select.intent-danger.active.sc-task-input-select{background:rgba(205, 66, 70, 0.3);color:#ac2f33}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:disabled,.select.minimal.sc-task-input-select select.intent-danger.disabled.sc-task-input-select{background:none;color:rgba(172, 47, 51, 0.5)}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select:disabled.active,.select.minimal.sc-task-input-select select.intent-danger.disabled.active.sc-task-input-select{background:rgba(205, 66, 70, 0.3)}.select.minimal.sc-task-input-select select.intent-danger.sc-task-input-select .button-spinner.sc-task-input-select .spinner-head.sc-task-input-select{stroke:#ac2f33}.select.large.sc-task-input-select select.sc-task-input-select{font-size:16px;height:40px;padding-right:35px}.select.sc-task-input-select select.sc-task-input-select:disabled{background-color:rgba(211, 216, 222, 0.5);-webkit-box-shadow:none;box-shadow:none;color:rgba(95, 107, 124, 0.6);cursor:not-allowed}.select.sc-task-input-select::after,.select.sc-task-input-select .icon.sc-task-input-select{color:#5f6b7c;pointer-events:none;position:absolute;right:7px;top:7px}.disabled.select.sc-task-input-select::after,.select.sc-task-input-select .disabled.icon.sc-task-input-select{color:rgba(95, 107, 124, 0.6)}.select.sc-task-input-select{display:inline-block;letter-spacing:normal;position:relative;vertical-align:middle}.select.sc-task-input-select select.sc-task-input-select::-ms-expand{display:none}.select.sc-task-input-select .icon.sc-task-input-select{color:#5f6b7c}.select.sc-task-input-select .icon.sc-task-input-select:hover{color:#1c2127}.select.large.sc-task-input-select::after,.select.large.sc-task-input-select .icon.sc-task-input-select{right:12px;top:12px}.select.fill.sc-task-input-select,.select.fill.sc-task-input-select select.sc-task-input-select{width:100%}.select.sc-task-input-select::after{font-family:\"blueprint-icons-16\", sans-serif;font-size:16px;font-style:normal;font-variant:normal;font-weight:400;line-height:1;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;content:\"\\f184\"}";
const TaskInputSelectStyle0 = taskInputSelectCss;

const TaskInputSelect$1 = /*@__PURE__*/ proxyCustomElement(class TaskInputSelect extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.inputUpdated = createEvent(this, "inputUpdated", 7);
        this.registerKeyboardShortcut = createEvent(this, "registerKeyboardShortcut", 7);
        this.shortcutMap = new Map();
        this.disconnectedCallback = InputBase.prototype.disconnectedCallback;
        this.formUpdated = InputBase.prototype.formUpdated;
        this.setupDependentInputs = InputBase.prototype.setupDependentInputs;
        this.hasAnswerToValidate = InputBase.prototype.hasAnswerToValidate;
        this.handleParentElementUpdate = InputBase.prototype.handleParentElementUpdate;
        this.fromInputUpdated = InputBase.prototype.fromInputUpdated.bind(this);
        this.name = undefined;
        this.label = undefined;
        this.labelClass = undefined;
        this.required = undefined;
        this.active = undefined;
        this.disabled = undefined;
        this.disableIf = undefined;
        this.requireIf = undefined;
        this.requiredIndicator = undefined;
        this.displayOn = undefined;
        this.displayIf = undefined;
        this.value = undefined;
        this.valueFrom = undefined;
        this.hidden = undefined;
        this.preventChanges = undefined;
        this.answer = undefined;
        this.answerCorrection = undefined;
    }
    componentWillLoad() {
        InputBase.prototype.componentWillLoad.bind(this)();
        this.options = gatherInputOptions(this.host);
        for (let ks of inputOptionKeyboardShortcuts(this.options)) {
            this.shortcutMap[ks.keys] = ks.value;
            this.registerKeyboardShortcut.emit(ks);
        }
    }
    connectedCallback() {
        InputBase.prototype.connectedCallback.bind(this)();
    }
    async readyToSubmit() { return InputBase.prototype.readyToSubmit.bind(this)(); }
    async validateAgainstAnswer() { return InputBase.prototype.validateAgainstAnswer.bind(this)(); }
    async setShowCorrections() { return InputBase.prototype.setShowCorrections.bind(this)(); }
    async handleValueUpdate() { return InputBase.prototype.handleValueUpdate.bind(this)(); }
    keypressHandler(event) {
        if (event.key in this.shortcutMap && this.active && !ignoreKeypress() && !this.disabled && !this.preventChanges) {
            const advance = this.value === this.shortcutMap[event.key];
            this.value = this.shortcutMap[event.key];
            // If the value doesn't change as a result of the key press, trigger card advance from here
            if (advance) {
                this.inputUpdated.emit(this.input.form);
            }
            // The following addresses an issue observed with dependent form elements
            // not receiving form updated events when the value is changed via keypress
            this.input.form.elements[this.name].value = this.shortcutMap[event.key];
            this.input.form.dispatchEvent(new InputEvent("input"));
        }
    }
    render() {
        return (h(Host, { key: '396254092a597b7ed454382cf19df2fda66da378' }, !this.hidden && h("label", { key: 'e7fee74bf4171197628eb248bbfac5f538b2d3df', class: this.labelClass }, this.label, h("div", { key: 'ab47d8a707b805d3153428076ee6d5488e399af5', class: "select" }, h("select", { key: '868ea66c4097238ebbfad3a7bd0990a55037eed6', name: this.name, required: this.required, disabled: this.disabled, onChange: e => this.value = e.target.value, ref: el => this.input = el }, this.options.map(option => h("option", { value: option.value, selected: option.value === this.value }, option.innerHTML))))), h("slot", { key: '2229ef6401a3a4b8aa8df588e3057e2abe90c48a' })));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "value": ["handleValueUpdate"],
        "required": ["handleValueUpdate"]
    }; }
    static get style() { return TaskInputSelectStyle0; }
}, [70, "task-input-select", {
        "name": [1],
        "label": [1],
        "labelClass": [1, "label-class"],
        "required": [1028],
        "active": [4],
        "disabled": [1028],
        "disableIf": [1, "disable-if"],
        "requireIf": [1, "require-if"],
        "requiredIndicator": [1, "required-indicator"],
        "displayOn": [1, "display-on"],
        "displayIf": [1, "display-if"],
        "value": [1025],
        "valueFrom": [1, "value-from"],
        "hidden": [1028],
        "preventChanges": [32],
        "answer": [32],
        "answerCorrection": [32],
        "readyToSubmit": [64],
        "validateAgainstAnswer": [64],
        "setShowCorrections": [64]
    }, [[4, "keypress", "keypressHandler"]], {
        "value": ["handleValueUpdate"],
        "required": ["handleValueUpdate"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-input-select"];
    components.forEach(tagName => { switch (tagName) {
        case "task-input-select":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskInputSelect$1);
            }
            break;
    } });
}

const TaskInputSelect = TaskInputSelect$1;
const defineCustomElement = defineCustomElement$1;

export { TaskInputSelect, defineCustomElement };

//# sourceMappingURL=task-input-select.js.map