import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const taskLinkCss = ".button.sc-task-link{display:-ms-inline-flexbox;display:inline-flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;border:none;border-radius:3px;cursor:pointer;font-size:14px;-ms-flex-pack:center;justify-content:center;padding:0 7px;text-align:center;text-decoration:none;transition:none;vertical-align:middle;min-height:24px;min-width:24px;background-color:#f6f7f9;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(17, 20, 24, 0)), to(rgba(17, 20, 24, 0.05)));background-image:linear-gradient(to bottom, rgba(17, 20, 24, 0), rgba(17, 20, 24, 0.05));-webkit-box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);box-shadow:inset 0 0 0 1px rgba(17, 20, 24, 0.2), inset 0 -1px 0 rgba(17, 20, 24, 0.1);color:#1c2127;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-webkit-box-align:center;-webkit-box-pack:center;-webkit-transition:none}";
const TaskLinkStyle0 = taskLinkCss;

const TaskLink$1 = /*@__PURE__*/ proxyCustomElement(class TaskLink extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.href = undefined;
        this.type = "link";
        this.customStyle = undefined;
    }
    render() {
        // TODO: Validate how the style is passed through and if the parse is appropriate
        return (h("a", { key: '32f1e6dc0f9f1f28077d35e077b47a725241213e', class: this.type, style: this.customStyle ? JSON.parse(this.customStyle) : null, target: "_blank", href: this.href }, h("slot", { key: '8b849a3f8ab989b70484bb171d2d7ed63521672f' })));
    }
    static get style() { return TaskLinkStyle0; }
}, [6, "task-link", {
        "href": [1],
        "type": [1],
        "customStyle": [1, "custom-style"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-link"];
    components.forEach(tagName => { switch (tagName) {
        case "task-link":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskLink$1);
            }
            break;
    } });
}

const TaskLink = TaskLink$1;
const defineCustomElement = defineCustomElement$1;

export { TaskLink, defineCustomElement };

//# sourceMappingURL=task-link.js.map