import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const taskTagCss = ".sc-task-tag-h{display:inline}.sc-task-tag-h{display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-direction:row;flex-direction:row;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:#5f6b7c;border:none;border-radius:3px;-webkit-box-shadow:none;box-shadow:none;color:#f6f7f9;font-size:12px;line-height:16px;max-width:100%;min-height:20px;min-width:20px;padding:2px 6px;position:relative;margin-right:4px;margin-bottom:4px}.interactive.sc-task-tag-h{cursor:pointer}.interactive.sc-task-tag-h:hover{background-color:rgba(95, 107, 124, 0)}.interactive.active.sc-task-tag-h,.interactive.sc-task-tag-h:active{background-color:rgba(95, 107, 124, 0)}.sc-task-tag-h>*.sc-task-tag{-webkit-box-flex:0;-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0}.sc-task-tag-h::before,task-tag.sc-task-tag>*.sc-task-tag{margin-right:4px}.sc-task-tag-h:empty::before,.sc-task-tag-h>.sc-task-tag:last-child{margin-right:0}.sc-task-tag-h:focus{outline:rgba(45, 114, 210, 0.6) auto 2px;outline-offset:0;-moz-outline-radius:6px}.round.sc-task-tag-h{border-radius:30px;padding-left:8px;padding-right:8px}.large.sc-task-tag-h,.large .sc-task-tag-h{font-size:14px;line-height:20px;min-height:30px;min-width:30px;padding:5px 10px}.large.sc-task-tag-h::before,.large.sc-task-tag-h>*.sc-task-tag,.large .sc-task-tag-h::before,.large .sc-task-tag-h>*.sc-task-tag{margin-right:7px}.large.sc-task-tag-h:empty::before,.large.sc-task-tag-h>.sc-task-tag:last-child,.large .sc-task-tag-h:empty::before,.large .sc-task-tag-h>.sc-task-tag:last-child{margin-right:0}.large.round.sc-task-tag-h,.large .round.sc-task-tag-h{padding-left:12px;padding-right:12px}.small.sc-task-tag-h,.small .sc-task-tag-h{font-size:11px;line-height:14px;min-height:14px;min-width:18px;padding:2px 6px}.small.sc-task-tag-h::before,.small.sc-task-tag-h>*.sc-task-tag,.small .sc-task-tag-h::before,.small .sc-task-tag-h>*.sc-task-tag{margin-right:4px}.small.sc-task-tag-h:empty::before,.small.sc-task-tag-h>.sc-task-tag:last-child,.small .sc-task-tag-h:empty::before,.small .sc-task-tag-h>.sc-task-tag:last-child{margin-right:0}.small.round.sc-task-tag-h,.small .round.sc-task-tag-h{padding-left:6px;padding-right:6px}.color-blue.sc-task-tag-h{background:#2d72d2;color:#fff}.color-blue.interactive.sc-task-tag-h{cursor:pointer}.color-blue.interactive.sc-task-tag-h:hover{background-color:rgba(45, 114, 210, 0)}.color-blue.interactive.active.sc-task-tag-h,.color-blue.interactive.sc-task-tag-h:active{background-color:rgba(45, 114, 210, 0)}.color-green.sc-task-tag-h{background:#238551;color:#fff}.color-green.interactive.sc-task-tag-h{cursor:pointer}.color-green.interactive.sc-task-tag-h:hover{background-color:rgba(35, 133, 81, 0)}.color-green.interactive.active.sc-task-tag-h,.color-green.interactive.sc-task-tag-h:active{background-color:rgba(35, 133, 81, 0)}.color-orange.sc-task-tag-h{background:#c87619;color:#fff}.color-orange.interactive.sc-task-tag-h{cursor:pointer}.color-orange.interactive.sc-task-tag-h:hover{background-color:rgba(200, 118, 25, 0)}.color-orange.interactive.active.sc-task-tag-h,.color-orange.interactive.sc-task-tag-h:active{background-color:rgba(200, 118, 25, 0)}.color-red.sc-task-tag-h{background:#cd4246;color:#fff}.color-red.interactive.sc-task-tag-h{cursor:pointer}.color-red.interactive.sc-task-tag-h:hover{background-color:rgba(205, 66, 70, 0)}.color-red.interactive.active.sc-task-tag-h,.color-red.interactive.sc-task-tag-h:active{background-color:rgba(205, 66, 70, 0)}.minimal.sc-task-tag-h:not([class*=bp4-intent-]){background-color:rgba(143, 153, 168, 0.2);color:#1c2127}.minimal.sc-task-tag-h:not([class*=bp4-intent-]).interactive{cursor:pointer}.minimal.sc-task-tag-h:not([class*=bp4-intent-]).interactive:hover{background-color:rgba(95, 107, 124, 0.102)}.minimal.sc-task-tag-h:not([class*=bp4-intent-]).interactive.active,.minimal.sc-task-tag-h:not([class*=bp4-intent-]).interactive:active{background-color:rgba(95, 107, 124, 0.202)}.minimal.color-blue.sc-task-tag-h{background-color:rgba(45, 114, 210, 0.15);color:#215db0}.minimal.color-blue.interactive.sc-task-tag-h{cursor:pointer}.minimal.color-blue.interactive.sc-task-tag-h:hover{background-color:rgba(45, 114, 210, 0.1015)}.minimal.color-blue.interactive.active.sc-task-tag-h,.minimal.color-blue.interactive.sc-task-tag-h:active{background-color:rgba(45, 114, 210, 0.2015)}.minimal.color-green.sc-task-tag-h{background-color:rgba(35, 133, 81, 0.15);color:#1c6e42}.minimal.color-green.interactive.sc-task-tag-h{cursor:pointer}.minimal.color-green.interactive.sc-task-tag-h:hover{background-color:rgba(35, 133, 81, 0.1015)}.minimal.color-green.interactive.active.sc-task-tag-h,.minimal.color-green.interactive.sc-task-tag-h:active{background-color:rgba(35, 133, 81, 0.2015)}.minimal.color-orange.sc-task-tag-h{background-color:rgba(200, 118, 25, 0.15);color:#935610}.minimal.color-orange.interactive.sc-task-tag-h{cursor:pointer}.minimal.color-orange.interactive.sc-task-tag-h:hover{background-color:rgba(200, 118, 25, 0.1015)}.minimal.color-orange.interactive.active.sc-task-tag-h,.minimal.color-orange.interactive.sc-task-tag-h:active{background-color:rgba(200, 118, 25, 0.2015)}.minimal.color-red.sc-task-tag-h{background-color:rgba(205, 66, 70, 0.15);color:#ac2f33}.minimal.color-red.interactive.sc-task-tag-h{cursor:pointer}.minimal.color-red.interactive.sc-task-tag-h:hover{background-color:rgba(205, 66, 70, 0.1015)}.minimal.color-red.interactive.active.sc-task-tag-h,.minimal.color-red.interactive.sc-task-tag-h:active{background-color:rgba(205, 66, 70, 0.2015)}-remove.sc-task-tag-h{background:none;border:none;color:inherit;cursor:pointer;display:-webkit-box;display:-ms-flexbox;display:flex;margin-bottom:-2px;margin-right:-6px !important;margin-top:-2px;opacity:0.5;padding:2px;padding-left:0}-remove.sc-task-tag-h:hover{background:none;opacity:0.8;text-decoration:none}-remove.sc-task-tag-h:active{opacity:1}-remove.sc-task-tag-h:empty::before{font-family:\"blueprint-icons-16\", sans-serif;font-size:16px;font-style:normal;font-variant:normal;font-weight:400;line-height:1;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;content:\"\\f2ba\"}.large -remove.sc-task-tag-h{margin-right:-10px !important;padding:0 5px 0 0}.large -remove.sc-task-tag-h:empty::before{font-family:\"blueprint-icons-20\", sans-serif;font-size:20px;font-style:normal;font-variant:normal;font-weight:400;line-height:1}.sc-task-tag-h{color:#fff}.sc-task-tag-h -remove.sc-task-tag,.sc-task-tag-h -remove.sc-task-tag:hover,.sc-task-tag-h -remove.sc-task-tag:active{opacity:1}.interactive.sc-task-tag-h:hover{background:#404854}.interactive.sc-task-tag-h:active{background:#383e47}.color-blue.sc-task-tag-h{background:#2d72d2;color:#fff}.color-blue.interactive.sc-task-tag-h:hover{background-color:#215db0}.color-blue.interactive.sc-task-tag-h:active{background-color:#184a90}.color-green.sc-task-tag-h{background:#238551;color:#fff}.color-green.interactive.sc-task-tag-h:hover{background-color:#1c6e42}.color-green.interactive.sc-task-tag-h:active{background-color:#165a36}.color-orange.sc-task-tag-h{background:#fbb360;color:#1c2127}.color-orange.interactive.sc-task-tag-h:hover{background-color:#ec9a3c}.color-orange.interactive.sc-task-tag-h:active{background-color:#c87619}.color-red.sc-task-tag-h{background:#cd4246;color:#fff}.color-red.interactive.sc-task-tag-h:hover{background-color:#ac2f33}.color-red.interactive.sc-task-tag-h:active{background-color:#8e292c}.minimal.sc-task-tag-h{background-color:rgba(143, 153, 168, 0.15);color:#1c2127}.minimal.interactive.sc-task-tag-h:hover{background-color:rgba(143, 153, 168, 0.3);color:#111418}.minimal.interactive.sc-task-tag-h:active{background-color:rgba(143, 153, 168, 0.35);color:#111418}.minimal.color-blue.sc-task-tag-h{background-color:rgba(45, 114, 210, 0.1);color:#215db0}.minimal.color-blue.interactive.sc-task-tag-h:hover{background-color:rgba(45, 114, 210, 0.2);color:#184a90}.minimal.color-blue.interactive.sc-task-tag-h:active{background-color:rgba(45, 114, 210, 0.3);color:#184a90}.minimal.color-green.sc-task-tag-h{background-color:rgba(35, 133, 81, 0.1);color:#1c6e42}.minimal.color-green.interactive.sc-task-tag-h:hover{background-color:rgba(35, 133, 81, 0.2);color:#165a36}.minimal.color-green.interactive.sc-task-tag-h:active{background-color:rgba(35, 133, 81, 0.3);color:#165a36}.minimal.color-orange.sc-task-tag-h{background-color:rgba(200, 118, 25, 0.1);color:#935610}.minimal.color-orange.interactive.sc-task-tag-h:hover{background-color:rgba(200, 118, 25, 0.2);color:#77450d}.minimal.color-orange.interactive.sc-task-tag-h:active{background-color:rgba(200, 118, 25, 0.3);color:#77450d}.minimal.color-red.sc-task-tag-h{background-color:rgba(205, 66, 70, 0.1);color:#ac2f33}.minimal.color-red.interactive.sc-task-tag-h:hover{background-color:rgba(205, 66, 70, 0.2);color:#8e292c}.minimal.color-red.interactive.sc-task-tag-h:active{background-color:rgba(205, 66, 70, 0.3);color:#8e292c}";
const TaskTagStyle0 = taskTagCss;

const TaskTag = /*@__PURE__*/ proxyCustomElement(class TaskTag extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.round = undefined;
        this.color = undefined;
        this.removable = undefined;
        this.large = undefined;
        this.small = undefined;
        this.minimal = undefined;
        this.interactive = undefined;
        this.onremove = () => { };
        this.removed = undefined;
    }
    classes() {
        const classList = [];
        if (this.round) {
            classList.push("round");
        }
        if (this.color) {
            classList.push("color-" + this.color);
        }
        if (this.large) {
            classList.push("large");
        }
        if (this.small) {
            classList.push("small");
        }
        if (this.minimal) {
            classList.push("minimal");
        }
        if (this.interactive) {
            classList.push("interactive");
        }
        return classList.join(" ");
    }
    render() {
        return (h(Host, { key: '1b9a5782d2a654bb82e586ffe55b99445a2c6f3d', class: this.classes() }, h("slot", { key: '954ad0c6d782781e1bfce79b19ac4d482df2d9c4' })));
    }
    static get style() { return TaskTagStyle0; }
}, [6, "task-tag", {
        "round": [4],
        "color": [1],
        "removable": [4],
        "large": [4],
        "small": [4],
        "minimal": [4],
        "interactive": [4],
        "onremove": [16],
        "removed": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-tag"];
    components.forEach(tagName => { switch (tagName) {
        case "task-tag":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskTag);
            }
            break;
    } });
}

export { TaskTag as T, defineCustomElement as d };

//# sourceMappingURL=task-tag2.js.map