import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { a as attachInputListener } from './inputBase.js';

const taskVarCss = ".sc-task-var-h{display:inline}";
const TaskVarStyle0 = taskVarCss;

const TaskVar$1 = /*@__PURE__*/ proxyCustomElement(class TaskVar extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.data = undefined;
        this.name = undefined;
        this.value = undefined;
    }
    componentWillLoad() {
        if (this.data) {
            let element = this.host;
            while (element.parentElement && !this.value) {
                element = element.parentElement;
                if (this.data in element.dataset) {
                    this.value = element.dataset[this.data];
                }
            }
        }
        else if (this.name) {
            if (['interactive', 'complete'].includes(document.readyState)) {
                this.setupInputListener();
            }
            else {
                this.loadCallback = this.setupInputListener.bind(this);
                document.addEventListener("load", this.setupInputListener);
            }
        }
    }
    disconnectedCallback() {
        if (this.loadCallback) {
            document.removeEventListener("load", this.loadCallback);
        }
    }
    setupInputListener() {
        this.inputCallback = this.inputUpdated.bind(this);
        attachInputListener(this.name, this.inputCallback)
            .then(input => {
            this.input = input;
            this.inputUpdated();
        });
    }
    inputUpdated() {
        if (this.input) {
            this.value = this.input.value;
        }
    }
    render() {
        return (h(Host, { key: 'd29f884d8c2027bcab046522d49671e149ecf81d' }, this.value, h("slot", { key: '52b5091e98ec0dfec7546d39b924fcd1aaffec6c' })));
    }
    get host() { return this; }
    static get style() { return TaskVarStyle0; }
}, [6, "task-var", {
        "data": [1],
        "name": [1],
        "value": [32]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["task-var"];
    components.forEach(tagName => { switch (tagName) {
        case "task-var":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TaskVar$1);
            }
            break;
    } });
}

const TaskVar = TaskVar$1;
const defineCustomElement = defineCustomElement$1;

export { TaskVar, defineCustomElement };

//# sourceMappingURL=task-var.js.map