import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-d23ea3f6.js';
import { c as childInputs } from './inputBase-67c8c8b2.js';
import './utils-d346b0ee.js';

const taskAnswerCorrectionCss = ".sc-task-answer-correction-h{display:block}.correction-hidden.sc-task-answer-correction-h{display:none}";
const TaskAnswerCorrectionStyle0 = taskAnswerCorrectionCss;

const TaskAnswerCorrection = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.display = createEvent(this, "display", 7);
        this.displayOn = "submit";
        this.showAnswer = false;
        this.preventChanges = false;
        this.displayCorrection = false;
        this.onDisplayEvent = undefined;
    }
    componentWillLoad() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = true;
        }
    }
    handleDisplayUpdate() {
        const inputs = childInputs(this.host);
        for (let input of inputs) {
            input.disabled = !this.displayCorrection;
        }
        this.display.emit(this.displayCorrection);
    }
    handleDisplay(event) {
        // TODO: This all could be refactored or abandoned
        if (this.onDisplayEvent) {
            let command = this.onDisplayEvent;
            if (command.includes("${visible}")) {
                command = command.replace("${visible}", event.detail.toString());
            }
            eval(command);
        }
    }
    render() {
        return (h(Host, { key: '8941a6c13fcbc1abeb7deb780143d651e92df960', class: this.displayCorrection ? "" : "correction-hidden" }, h("slot", { key: '089b450d018cff137ee2152aa76ce1326436adbe' })));
    }
    get host() { return getElement(this); }
    static get watchers() { return {
        "displayCorrection": ["handleDisplayUpdate"]
    }; }
};
TaskAnswerCorrection.style = TaskAnswerCorrectionStyle0;

export { TaskAnswerCorrection as task_answer_correction };

//# sourceMappingURL=task-answer-correction.entry.js.map