import { r as registerInstance, h, H as Host } from './index-d23ea3f6.js';
import { c as computeBoxLocation } from './image-2691bb93.js';

const taskImageBoxCss = ".sc-task-image-box-h{display:none}";
const TaskImageBoxStyle0 = taskImageBoxCss;

const TaskImageBox = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.top = undefined;
        this.left = undefined;
        this.width = undefined;
        this.height = undefined;
        this.coordinates = undefined;
        this.lineWidth = 5;
        this.color = "green";
        this.location = undefined;
    }
    componentWillLoad() {
        this.location = computeBoxLocation(this.left, this.top, this.width, this.height, this.coordinates);
    }
    async drawBox(context, scalar = 1, xOffset = 0, yOffset = 0) {
        if (this.location) {
            const l = this.location.map(x => x * scalar);
            context.beginPath();
            context.lineWidth = this.lineWidth;
            context.strokeStyle = this.color;
            context.rect(l[0] + xOffset, l[1] + yOffset, l[2], l[3]);
            context.stroke();
        }
    }
    /*
    This was a small experiment exploring using calculated lineWidth based on weight and dimensions
    computeWidth(width: number, height: number, weight: number) {
      const minDimension = Math.min(width, height)
      console.log("Min dimension: " + minDimension)
      return 5
    }
     */
    render() {
        return (h(Host, { key: 'b7c45a64669dbbf3fd00e3b4af236e38d7913bad' }, h("slot", { key: '372cd03ff872745f0da33388424ab4ca42971b08' })));
    }
};
TaskImageBox.style = TaskImageBoxStyle0;

export { TaskImageBox as task_image_box };

//# sourceMappingURL=task-image-box.entry.js.map