import { r as registerInstance, h, H as Host, g as getElement } from './index-d23ea3f6.js';
import { b as ignoreKeypress } from './utils-d346b0ee.js';

const taskStepsCss = ".sc-task-steps-h{display:block}";
const TaskStepsStyle0 = taskStepsCss;

const TaskSteps = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.activeStep = 0;
        this.steps = undefined;
    }
    componentWillLoad() {
        this.steps = Array.from(this.host.children).filter(node => node.nodeName === "TASK-STEP");
        this.updateActiveStep();
    }
    updateActiveStep() {
        for (let step of this.steps) {
            step.active = this.activeStep === this.steps.indexOf(step);
        }
    }
    cardClickedHandler(event) {
        const target = event.detail;
        if (this.steps.includes(target)) {
            this.activeStep = this.steps.indexOf(target);
        }
    }
    cardReadyToSubmitHandler(event) {
        if (event.detail && !ignoreKeypress()) {
            this.activeStep = Math.min(this.activeStep + 1, this.steps.length - 1);
        }
    }
    activeStepUpdated() {
        this.updateActiveStep();
    }
    render() {
        return (h(Host, { key: 'bbc318c8cc88ad26b6fd143abfb936989328b69d' }, h("slot", { key: '368a76619c5e0ada7c0b2ed7590a63fd89ae5f78' })));
    }
    get host() { return getElement(this); }
    static get watchers() { return {
        "activeStep": ["activeStepUpdated"]
    }; }
};
TaskSteps.style = TaskStepsStyle0;

export { TaskSteps as task_steps };

//# sourceMappingURL=task-steps.entry.js.map