import { r as registerInstance, h, H as Host, g as getElement } from './index-d23ea3f6.js';
import { b as attachInputListener } from './inputBase-67c8c8b2.js';
import './utils-d346b0ee.js';

const taskVarCss = ".sc-task-var-h{display:inline}";
const TaskVarStyle0 = taskVarCss;

const TaskVar = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.data = undefined;
        this.name = undefined;
        this.value = undefined;
    }
    componentWillLoad() {
        if (this.data) {
            let element = this.host;
            while (element.parentElement && !this.value) {
                element = element.parentElement;
                if (this.data in element.dataset) {
                    this.value = element.dataset[this.data];
                }
            }
        }
        else if (this.name) {
            if (['interactive', 'complete'].includes(document.readyState)) {
                this.setupInputListener();
            }
            else {
                this.loadCallback = this.setupInputListener.bind(this);
                document.addEventListener("load", this.setupInputListener);
            }
        }
    }
    disconnectedCallback() {
        if (this.loadCallback) {
            document.removeEventListener("load", this.loadCallback);
        }
    }
    setupInputListener() {
        this.inputCallback = this.inputUpdated.bind(this);
        attachInputListener(this.name, this.inputCallback)
            .then(input => {
            this.input = input;
            this.inputUpdated();
        });
    }
    inputUpdated() {
        if (this.input) {
            this.value = this.input.value;
        }
    }
    render() {
        return (h(Host, { key: 'd29f884d8c2027bcab046522d49671e149ecf81d' }, this.value, h("slot", { key: '52b5091e98ec0dfec7546d39b924fcd1aaffec6c' })));
    }
    get host() { return getElement(this); }
};
TaskVar.style = TaskVarStyle0;

export { TaskVar as task_var };

//# sourceMappingURL=task-var.entry.js.map