import { EventEmitter } from '../../stencil-public-runtime';
import { Input, InputEventTarget } from '../../utils/inputBase';
import { CallbackFunction, KeyboardShortcut } from '../../utils/utils';
import { TaskAnswer } from '../task-answer/task-answer';
import { TaskAnswerCorrection } from '../task-answer-correction/task-answer-correction';
export declare class TaskInputMultiselect implements Input {
    name: string;
    label: string;
    labelClass: string;
    required: boolean;
    active: boolean;
    disabled: boolean;
    disableIf: string;
    requireIf: string;
    requiredIndicator: string;
    displayOn: string;
    displayIf: string;
    value: string;
    valueFrom: string;
    hidden: boolean;
    preventChanges: boolean;
    answer: TaskAnswer;
    answerCorrection: TaskAnswerCorrection;
    inputUpdated: EventEmitter<HTMLElement>;
    host: HTMLElement;
    input: HTMLInputElement | HTMLTextAreaElement | HTMLSelectElement;
    fromInput: InputEventTarget;
    form: HTMLFormElement;
    loadCallback: CallbackFunction;
    formCallback: CallbackFunction;
    displayOnCallback: CallbackFunction;
    placeholder: string;
    options: HTMLTaskInputOptionElement[];
    optionsMap: Map<string, string>;
    values: string[];
    shortcutMap: Map<string, string>;
    optionsDisplayed: boolean;
    registerKeyboardShortcut: EventEmitter<KeyboardShortcut>;
    button: HTMLButtonElement;
    optionsDropdown: HTMLDivElement;
    cleanup: Function;
    ro: ResizeObserver;
    connectedCallback(): void;
    formUpdated: () => void;
    setupDependentInputs: () => void;
    hasAnswerToValidate: () => boolean;
    handleParentElementUpdate: () => void;
    fromInputUpdated: any;
    validateAgainstAnswer(): Promise<any>;
    setShowCorrections(): Promise<any>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    handleButtonClick(): void;
    handleDocumentClick(event: any): void;
    handleBlur(event: any): void;
    updatePosition(): void;
    handleChange(event: Event): void;
    readyToSubmit(): Promise<boolean>;
    handleValueUpdate(): void;
    handleOptionSelect(e: Event, value: string): void;
    render(): any;
}
