import { EventEmitter } from '../../stencil-public-runtime';
import { Input, InputEventTarget } from '../../utils/inputBase';
import { CallbackFunction, KeyboardShortcut } from '../../utils/utils';
import { TaskAnswer } from '../task-answer/task-answer';
import { TaskAnswerCorrection } from '../task-answer-correction/task-answer-correction';
export declare class TaskInputSelect implements Input {
    name: string;
    label: string;
    labelClass: string;
    required: boolean;
    active: boolean;
    disabled: boolean;
    disableIf: string;
    requireIf: string;
    requiredIndicator: string;
    displayOn: string;
    displayIf: string;
    value: string;
    valueFrom: string;
    hidden: boolean;
    preventChanges: boolean;
    answer: TaskAnswer;
    answerCorrection: TaskAnswerCorrection;
    inputUpdated: EventEmitter<HTMLElement>;
    host: HTMLElement;
    input: HTMLInputElement | HTMLTextAreaElement | HTMLSelectElement;
    fromInput: InputEventTarget;
    form: HTMLFormElement;
    loadCallback: CallbackFunction;
    formCallback: CallbackFunction;
    displayOnCallback: CallbackFunction;
    options: HTMLTaskInputOptionElement[];
    shortcutMap: Map<string, string>;
    registerKeyboardShortcut: EventEmitter<KeyboardShortcut>;
    componentWillLoad(): void;
    connectedCallback(): void;
    disconnectedCallback: () => void;
    formUpdated: () => void;
    setupDependentInputs: () => void;
    hasAnswerToValidate: () => boolean;
    handleParentElementUpdate: () => void;
    fromInputUpdated: any;
    readyToSubmit(): Promise<any>;
    validateAgainstAnswer(): Promise<any>;
    setShowCorrections(): Promise<any>;
    handleValueUpdate(): Promise<any>;
    keypressHandler(event: KeyboardEvent): void;
    render(): any;
}
