import { EventEmitter } from '../../stencil-public-runtime';
import { Input, InputEventTarget } from '../../utils/inputBase';
import { TaskAnswer } from '../task-answer/task-answer';
import { TaskAnswerCorrection } from '../task-answer-correction/task-answer-correction';
import { CallbackFunction } from '../../utils/utils';
export declare class TaskInput implements Input {
    name: string;
    label: string;
    labelClass: string;
    required: boolean;
    active: boolean;
    disabled: boolean;
    disableIf: string;
    requireIf: string;
    requiredIndicator: string;
    displayOn: string;
    displayIf: string;
    value: string;
    valueFrom: string;
    hidden: boolean;
    preventChanges: boolean;
    answer: TaskAnswer;
    answerCorrection: TaskAnswerCorrection;
    inputUpdated: EventEmitter<HTMLElement>;
    host: HTMLElement;
    input: HTMLInputElement | HTMLTextAreaElement | HTMLSelectElement;
    fromInput: InputEventTarget;
    form: HTMLFormElement;
    loadCallback: CallbackFunction;
    formCallback: CallbackFunction;
    displayOnCallback: CallbackFunction;
    type: string;
    rows: number;
    cols: number;
    size: number;
    maxlength: number;
    placeholder: string;
    internals: ElementInternals;
    componentWillLoad: () => void;
    connectedCallback(): void;
    disconnectedCallback: () => void;
    formUpdated: () => void;
    setupDependentInputs: () => void;
    hasAnswerToValidate: () => boolean;
    handleParentElementUpdate: () => void;
    fromInputUpdated: any;
    readyToSubmit(): Promise<any>;
    validateAgainstAnswer(): Promise<any>;
    setShowCorrections(): Promise<any>;
    handleValueUpdate(): Promise<any>;
    text(): any;
    textarea(): any;
    render(): any;
}
