import { EventEmitter } from '../../stencil-public-runtime';
export declare class TaskOverlay {
    isOpen: boolean;
    autoFocus: boolean;
    containerClass: string;
    enforceFocus: boolean;
    canEscapeKeyClose: boolean;
    canOutsideClickClose: boolean;
    hasBackdrop: boolean;
    shouldReturnFocusOnClose: boolean;
    transitionName: string;
    transitionDuration: number;
    backdropClass: string;
    host: HTMLElement;
    close: EventEmitter;
    closed: EventEmitter;
    closing: EventEmitter;
    opened: EventEmitter;
    opening: EventEmitter;
    isAutoFocusing: boolean;
    lastActiveElementBeforeOpened: Element | null | undefined;
    startFocusTrapElement: HTMLDivElement;
    backdropElement: HTMLDivElement;
    endFocusTrapElement: HTMLDivElement;
    children: HTMLElement[];
    componentWillLoad(): void;
    componentDidLoad(): void;
    watchIsOpen(newValue: boolean, oldValue: boolean): void;
    disconnectedCallback(): void;
    bringFocusInsideOverlay(): number;
    maybeRenderChild: (child?: HTMLElement) => HTMLElement;
    /**
     * Ensures repeatedly pressing shift+tab keeps focus inside the Overlay. Moves focus to
     * the `endFocusTrapElement` or the first keyboard-focusable element in the Overlay (excluding
     * the `startFocusTrapElement`), depending on whether the element losing focus is inside the
     * Overlay.
     */
    handleStartFocusTrapElementFocus: (e: FocusEvent) => void;
    /**
     * Wrap around to the end of the dialog if `enforceFocus` is enabled.
     */
    handleStartFocusTrapElementKeyDown: (e: KeyboardEvent) => void;
    /**
     * Ensures repeatedly pressing tab keeps focus inside the Overlay. Moves focus to the
     * `startFocusTrapElement` or the last keyboard-focusable element in the Overlay (excluding the
     * `startFocusTrapElement`), depending on whether the element losing focus is inside the
     * Overlay.
     */
    handleEndFocusTrapElementFocus: (e: FocusEvent) => void;
    getKeyboardFocusableElements(): HTMLElement[];
    overlayWillOpen(): void;
    overlayWillClose(): void;
    handleBackdropMouseDown: () => void;
    handleDocumentClick: (e: MouseEvent) => void;
    handleDocumentFocus: (e: FocusEvent) => void;
    handleKeyDown(e: KeyboardEvent): void;
    render2(): any;
    render(): any;
}
