type FetchFunction = (input: RequestInfo | URL, init?: RequestInit) => Promise<Response>;
type Mark = {
    name: string;
    time: number;
};
type TelemetryValue = {
    seconds: object;
    markCounts: object;
    totalSeconds: object;
    totalMarkCounts: object;
    attributes: object;
    startTimestamp: string;
    submitTimestamp?: string;
    response?: object;
};
type StoredTelemetry = {
    seconds: object;
    markCounts: object;
    priorData?: StoredTelemetry;
};
type TimeMeasure = {
    name: string;
    startMark: string;
    endMark: string;
};
export declare class TaskTelemetry {
    name: string;
    submitEndpoint: string;
    heartbeatEndpoint: string;
    heartbeatInterval: number;
    localStorageId: string;
    includeResponse: boolean;
    value: TelemetryValue;
    host: HTMLElement;
    input: HTMLInputElement;
    fetchMethod: FetchFunction;
    attributes: object;
    recordingActive: boolean;
    idle: boolean;
    internalHeartbeat: number;
    heartbeat: number;
    priorData: StoredTelemetry;
    lastHeartbeatTime: object;
    startTimestamp: string;
    timeMeasures: TimeMeasure[];
    connectedCallback(): void;
    disconnectedCallback(): void;
    markFocusEventHandler(event: Event): void;
    markEventHandler(event: Event): void;
    fetcher(input: RequestInfo | URL, init?: RequestInit): Promise<Response>;
    sendHeartbeat(): Promise<void | Response>;
    handleSubmit(): Promise<void | Response>;
    persistData(isSubmit?: boolean): void;
    computeTimeMeasures(marks: Mark[], isSubmit?: boolean): {};
    setFetchMethod(func: Function): Promise<void>;
    mark(name: string): Promise<void>;
    addTimeMeasure(name: string, startMark: string, endMark: string): Promise<void>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    render(): any;
}
export {};
